mksh (56c-2) unstable; urgency=low

  * The “stets vermißt, feiner Kerl” release
  * Update to a CVS snapshot as of 2018-10-20
    - [gecko2] Update operating environment reporting for the Macintosh
    - [Martijn Dekker] make ${foo#'bar'} in here document behave like ksh93
    - [Martijn Dekker] quote empty strings for re-entry into shell
    - [tg, G.raud Meyer] Improve documentation, especially for tty states
    - [tg] Protect against entering line editing with bad saved tty state
    - [tg] Fix set -o allexport for arrays (which we apparently do)
    - [tg] Handle lseek(2) returning -1 as pointed out by Coverity Scan
    - [tg] Fix left-padding UTF-8 strings
    - [tg, G.raud Meyer] Fix using the “-m” flag on the command line
    - [tg] Update to UCD 11.0.0
    - [multiplexd] Fix a segfault using ^W during search in Vi mode
    - [tg] Fix an error message; add a test for controlling tty
    - [tg] Permit unsetting LINES and COLUMNS, for those who need it
    - [tg] Fix manpage bug (RedHat BZ#1612173)
    - [tg] Minor spelling cleanup
    - [tg] Unbreak high-bit7 (nōn-ASCII) heredoc separators (LP#1779179)
    - [tg] Allow dumping high-bit7-char-containing strings in DEBUG mode
    - [tg] Add some testcases for behaviour questions popped up in IRC
  * Bump to Policy 4.2.1.2
    - handle new “terse” build option
    - R³:no
  * Update list of architectures on which musl is available
  * Add some UMEGAYA metadata
  * Update lintian overrides

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 20 Oct 2018 22:48:04 +0200

mksh (56c-1) unstable; urgency=high

  * New upstream bugfix release:
    - [komh] Remove redundant OS/2-specific code, clean up others
    - [komh, tg] Fix drive-qualified (absolute and relative) DOS-style
      path support in realpath functionality, partially other places
    - [tg] Don’t substitute ${ENV:-~/.mkshrc} result again
    - [tg] Improve OS/2 $PATH (et al.) handling, drive-relative paths
    - [tg] Add MKSH_ENVDIR compile-time option for Jehanne and Plan 9
    - [tg] Update wcwidth data with bugfixed script (still Unicode 10;
      resulting values are identical to glibc git master for extant chars)
    - [Dr. Werner Fink] Raise some time limits in the testsuite
    - [Shamar] Add support for the Jehanne operating system
    - [komh] Set stdin to text mode before executing child processes on OS/2
    - [komh] Pass arguments via a resonse file if executing a child fails
    - [Dr. Werner Fink] Early locale tracking as a compile-time option
    - [tg] Fix regressions introduced with new fast character classes
  * Urgency high due to the bugfixes (credits Daniel Martí, Jakub Wilk)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 14 Jan 2018 03:12:49 +0100

mksh (56b-4) unstable; urgency=low

  * Use http, not https, for the homepage, to make it accessible
    from Debian buster/sid OpenSSL
  * Update VCS-* to new repository caused by Alioth deprecation
  * Update from MirBSD CVS HEAD
  * Policy 4.1.3 (no change)
    - we require Built-Using for licence reasons in a non-negligible
      number of cases, so we’ve got to keep using it
  * Debhelper 11, insisted on by lintian
  * Update lintian overrides

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 05 Jan 2018 21:34:02 +0100

mksh (56b-3) unstable; urgency=medium

  * The “I’m not gonna do the release dance until you tell me you’re
    done checking this” upload
  * Update from MirBSD CVS HEAD (Closes: #878947)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 21 Oct 2017 21:25:15 +0200

mksh (56b-2) unstable; urgency=high

  * Work around #813164 in /etc/skel/.mkshrc
  * Policy 4.1.1 (no change)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 03 Oct 2017 17:26:54 +0200

mksh (56b-1) unstable; urgency=medium

  * Add $(which editor) to the fallback editor list, lowest priority
  * New upstream bugfix-only release, celebrating 15 years of MirBSD:
    - [tg] Reference the FAQ webpage
    - [panpo, Riviera] Fix documentation bug wrt. Esc+Ctrl-L
    - [tg, Larry Hynes] Fix “0” movement in vi mode
    - [tg] Replace broken libcs’ offsetof macro with MirBSD’s
  * Handle “note:” compiler output for mirtoconf consistently
  * Bump S-V, no relevant changes

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 29 Aug 2017 16:11:40 +0200

mksh (56-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream formal release:
    - [tg, Seb] Do not apply alias name restrictions to hash/tilde tracking
    - [tg] Restore ‘.’, ‘:’ and ‘[’ in alias names (“[[” is still forbidden)
    - [tg] Fix accidentally defanged $PATHSEP test
    - [tg] On ^C (INTR and QUIT edchars), shove edit line into history
    - [iSKUNK, tg] Begin porting to z/OS using EBCDIC encoding, incomplete
    - [tg] Redo fast character classes code, adding POSIX and other helpers
    - [tg] bind parses backslash-escaped ‘^’ (and ‘\’) as escaped
    - [tg] Building with -DMKSH_ASSUME_UTF8=0 no longer causes a known
      failure in the testsuite
    - [tg] New test.sh option -U to pass a UTF-8 locale to use in the tests
    - [tg] re_format(7) BSD: [[ $x = *[[:\<:]]foo[[:>:]]* ]]
    - [tg, iSKUNK] Use Config in check.pl only if it exists
    - [tg] New matching code for bracket expressions, full POSIX (8bit)
    - [komh] Exclude FAT/HPFS/NTFS-unsafe tests on OS/2 (and Cygwin/MSYS)
    - [tg] Update to Unicode 10.0.0
    - [tg, selk] Make readonly idempotent
    - [tg, multiplexd] When truncating the persistent history, do not change
      the underlying file, do all operations on the locked one; do not stop
      using the history at all if it has been truncated
    - [tg, J�rg] Turn off UTF-8 mode upon turning on POSIX mode
    - [Martijn Dekker, Geoff Clare, many on the Austin list, tg] In POSIX
      mode, make the exec builtin force a $PATH search plus execve
    - [tg] Fix GCC 7, Coverity Scan warnings
    - [tg, Michal Hlavinka] Track background process PIDs even interactive
    - [tg] Always expose mksh’s hexdump shell function; speed it up by
      working on the input in chunks; use character classes to make it
      EBCDIC safe
    - [tg] Revamp dot.mkshrc default editor selection mechanism
  * Policy 4.0.1; no changes AFAICT
  * Update lintian overrides, NEWS entry

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 09 Aug 2017 04:35:42 +0200

mksh (55-1) experimental; urgency=low

  * Upload to experimental during the freeze
  * New upstream formal release:
    - [komh] Fix OS/2 search_access() and UNC path logic
    - [tg] Undocument printf(1) to avoid user confusion
    - [Jean Delvare, tg] Fix printf builtin -R option
    - [tg] Make ${var@x}, unknown x, fail (thanks izabera)
    - [tg] ${var=x} must evaluate x in scalar context (10x Martijn Dekker)
    - [tg] Fixup relation between lksh and mksh, reduce delta
    - [tg] Improve manpage display; add OS/2 $PATH FAQ
    - [Jean Delvare] Fix bugs in manpage
    - [tg] Review tilde expansion, removing “odd use of KEEPASN” and introduce
      POSIX “declaration utility” concept; wait isn’t one
    - [tg] Add \builtin utility, declaration utility forwarder
    - [tg] Make $'\xz' expand to xz, not \0
    - [tg] Use fixed string pooling (requires the above change in host mksh)
    - [tg] POSIX declaration commands can have varassign and redirections
    - [Martijn Dekker] Add typeset -g, replacing homegrown “global”
    - [Harvey-OS] Disable NOPROSPECTOFWORK, APEX is reportedly fixed now
    - [tg] Display ulimit -a output with flags; improve Haiku
    - [tg] Drop old let] hack, use \builtin internally
    - [tg] Fix padding in Lb64encode in dot.mkshrc
    - [tg] Move FAQ content to a separate, new FAQ section in the manpage
    - [tg] Add new standard variable PATHSEP (‘:’, ‘;’ on OS/2)
    - [Martijn Dekker] Fix LINENO in eval and alias
    - [komh] Fix “\builtin” on OS/2
    - [tg] Improve (internal) character classes code for speed
    - [tg] Fix: the underscore is no drive letter
    - [tg] No longer hard-disable persistent history support in lksh
    - [tg] Introduce build flag -T for enabling “textmode” on OS/2 (supporting
      CR+LF line endings, but incompatible with mksh proper)
    - [tg] Merge mksh-os2
    - [tg] Permit changing $OS2_SHELL during a running shell
    - [tg] Fix multibyte handling in ^R (Emacs search-history)
    - [tg] Allow “typeset -p arrname[2]” to work
    - [tg] Make some error messages more consistent
    - [tg, komh] Disable UTF-8 detection code for OS/2 as unrealistic
    - [tg, sdaoden] Limit alias name chars to POSIX plus non-leading ‘-’
    - [tg, Martijn Dekker] Expand aliases at COMSUB parse time
    - [tg] Make “typeset -f” output alias-resistent
    - [tg, Martijn Dekker] Permit “eval break” and “eval continue”
    - [tg] Make -masm=intel safe on i386
    - [tg] Disambiguate $((…)) vs. $((…)…) in “typeset -f” output
    - [Jean Delvare] Clarify the effect of exit and return in a subshell
    - [tg] Simplify compile-time asserts and make them actually compile-time
    - [tg] Fix ^O in Emacs mode if the line was modified (LP#1675842)
    - [tg] Address Coverity Scan… stuff… now that it builds again
    - [Martijn Dekker, tg] Add test -v
    - [tg] Document set -o posix/sh completely
  * Update “uhr” from MirBSD CVS
  * Add NEWS entry with user-visible changes
  * Update lintian overrides
  * Apply scripting changes (“\builtin”, etc.) to /etc/skel/.mkshrc

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 12 Apr 2017 21:52:34 +0200

mksh (54-2) unstable; urgency=medium

  * Drop all '-specs=*' from CFLAGS and LDFLAGS, this nonsense
    causes FTBFS all over the place, e.g. in openssl1.0 too ☹

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 12 Nov 2016 02:37:10 +0100

mksh (54-1) unstable; urgency=medium

  [ John Paul A̲d̲r̲i̲a̲n̲ Glaubitz ]
  * Explain precisely which device nodes are needed in the chroot,
    and which permissions and ownership are required for openpty
    (cf. #841935, #817236)

  [ Thorsten Glaser ]
  * Fix wrong URL in debian/copyright
  * Move to debhelper compat 10 for stretch/sid
  * debian/control: Add explicit branches to VCS-* URIs
  * Remove obsolete dietlibc-specific warning message from the logs
  * New upstream formal release:
    - [tg] Simplify and improve code and manual page
    - [tg] Try GCC 5’s new -malign-data=abi
    - [tg] Allow interrupting builtin cat even on fast devices (LP#1616692)
    - [tg] Update to Unicode 9.0.0
    - [Andreas Buschka] Correct English spelling
    - [tg] Handle set -e-related error propagation in || and && constructs
      correctly
    - [tg] Initialise memory for RNG even when not targeting Valgrind
    - [tg] Shrink binary size
    - [Brian Callahan] Improve support for the contemporary pcc compiler
    - [tg] Fix side effects with lazy evaluation; spotted by ormaaj
    - [tg] New flags -c (columnise), -l, -N for the print builtin
    - [Larry Hynes] Fix English, spelling mistakes, typos in the manpage
    - [tg, ormaah] Return 128+SIGALRM if read -t times out, like GNU bash
    - [Martijn Dekker] Install both manpages from Build.sh
    - [Martijn Dekker] Document case changes are ASCII-only
    - [Ronald G. Minnich, Elbing Miss, Álvaro Jurado, tg] Begin porting to
      Harvey-OS and APEX (similar to Plan 9 and APE)
    - [KO Myung-Hun] More infrastructure for the OS/2 (EMX, KLIBC) port

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 12 Nov 2016 02:07:59 +0100

mksh (53a-1) unstable; urgency=medium

  * The “I need FTTH” release
  * New upstream release (Closes: #834161)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 12 Aug 2016 19:03:13 +0200

mksh (53-1) unstable; urgency=medium

  * The “Yellow Submarine” release
  * Upload to unstable
    - Build against musl as well
    - Do not consider builds that fail the regression test suite usable
    - Fixes in the Debian packaging
    - Re-enable debugging in dietlibc builds, should be less fragile now
    - Update lintian overrides
  * Update VCS-* URLs… again
  * Note dietlibc platforms added in experimental
  * Reorder static binary preference: klibc>musl>dietlibc>glibc
  * /usr/bin/diet is alternatives-managed now, adjust Built-Using generator
  * New upstream release:
    - [tg, TNF] Fix bounds checks in Vi editing mode
    - [tg] Handle combining characters at end of string or output correctly
    - [tg] Fix ${!#} ${!?} ${!-} (POSIX, prompted by izabera)
    - [tg] Fix shf.c-internal buffer overread on printing digits
    - [J�rg] Fix a typo in the testsuite
    - [arekm] Increase default edit line size (unless MKSH_SMALL)
    - [tg] Improve description of Emacs mode keybindings, especially ^U
    - [tg, arekm, jilles] Abort read builtin in case of read(2) errors
    - [tg, izabera, carstenh] Fix most of the ambiguous corner cases related
      to ${[pfx]var[op[word]]} (${@:-1} still unsupported)
    - [carstenh] Contribute some more testsuite coverage
    - [tg] WDS_TPUTS now emits QCHAR newline reentrant-safe
    - [tg] Fix var=<< implementation (LP#1380389)
    - [tg, FreeBSD] Make XSI test(1) extensions behave as if they were POSIX
    - [tg, izabera] Add $(<<<x) and $(<<EOF…) implementation
    - [tg] Lower minimum screen size accepted as “sane” from the OS to 4×2
    - [tg, Torsten Sillke] Simplify tilde-expanded parameters
    - [tg, Torsten Sillke] Fix default PS1 for substring matches
    - [tg] Apply defer-builtin-with-arguments logic to realpath builtin
    - [tg] Rework string pooling (own vs. compiler’s) (LP#1580348)
    - [tg] Feature: print -A, prints arguments as characters
    - [tg, izabera] Replace <<< and >>> as ROL and ROR operators with their
      new ^< and ^> spelling as per David Tribble’s proposal
    - [tg, slagtc] Clear-to-EOL under tmux to work around its anti-feature
    - [tg, p120ph37] Remove support for using file descriptors with more
      than a single digit, in preparation for named file descriptors
    - [tg] Correct, but simplify (at the potential cost of more tty I/O than
      strictly necessary, though never redundant and (probably) not more
      than before when it was miscalculated), line clearing and redrawing
    - [slagtc, tg] Implement new evaluate-region editing command Esc+Ctrl-E
    - [tg] Prefer external rename utility over the recovery builtin
    - [tg] Remove redundant full-line redraws
    - [tg, Natureshadow] Fix errorlevel of ‘.’ (“dot” special builtin) when
      the sourced script does not run any commands, for POSIX compliance
    - [tg] Refactor op tokens and edchars to shave off some more bytes
    - [tg] Fix some bugs in the manpage and some occasional/minor code bugs
    - [tg, Brian Callahan] Mark tests requiring new perl as !need-pass
    - [tg, slagtc] Add $KSH_MATCH and, to make it usable, ${foo@/bar/baz}
    - [tg, Score_Under] Fix bogus patch from OpenBSD: only NULL the global
      source in unwind when actually reclaiming its Area
    - [izabera] Mention in the manpage that integer bases go up to 36
  * Add NEWS entry with user-visible changes
  * Do not call script(1) with -q – we may need the debugging output
  * Work with dpkg-buildflags bugfix vs. reproducible builds effort again…

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Aug 2016 20:41:14 +0200

mksh (52c-2exp3) experimental; urgency=low

  [ Christian Seiler ]
  * Add dietlibc/mips64el

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 12 May 2016 13:00:41 +0200

mksh (52c-2exp2) experimental; urgency=low

  [ Thorsten Glaser ]
  * Build against musl as well
  * Do not consider builds that fail the regression test suite usable
  * Fix a typo in the package description
  * A couple minor fixes to the Debian packaging
  * Re-enable debugging in dietlibc builds, should be less fragile now
  * Update lintian overrides

  [ Christian Seiler ]
  * Test another two, genuinely new, architectures for dietlibc

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 10 May 2016 10:39:12 +0200

mksh (52c-2exp1) experimental; urgency=low

  * Require dietlibc from experimental (for experimental uploads ONLY)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 12 Apr 2016 16:11:58 +0200

mksh (52c-2) unstable; urgency=low

  * Bump Policy; the Debian menu system is now deprecated, but we’ll
    continue using it, for a while; a Desktop file isn’t currently needed
  * Update to upstream CVS HEAD:
    - [tg] Unbreak multi-line command history broken by history flush
      (Closes: #783978) (again…)
    - [tg] Fix redefining POSIX functions that were Korn functions before
  * Build mksh-static against all supported libcs, for QA; add NEWS entry
  * Update lintian overrides

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 12 Apr 2016 15:38:10 +0200

mksh (52c-1) unstable; urgency=low

  * New upstream bugfix-only release:
    - [tg] Shave 200 bytes off .text by revisiting string pooling
    - [tg, J�rg] Fix manpage for ditroff on Schillix
    - [tg, wbx] Use sed 1q instead of unportable head(1)
    - [tg] Implement underrun debugging tool for area-based memory allocator
    - [tg] Fix history underrun when first interactive command is entered
    - [tg, bef0rd] Do not misinterpret “${0/}” as “${0//”, fixes segfault
    - [tg, Stéphane Chazelas] Fix display problems with special parameters
    - [tg, Stéphane Chazelas] Catch attempt to trim $* and $@ with ?, fixes
      segfault (millert@ did this in 2004 for ${x[*]} already, so just sync)
    - [Martijn Dekker] Fix “command -p” with -Vv to behave as POSIX requires
    - [tg, jilles, Oleg Bulatov] Fix recusive parser with active heredocs
    - [tg] Flush even syntax-failing or interrupted commands to history
    - [tg, fmunozs] Fix invalid memory access for “'\0'” in arithmetics
    - [tg] Explicitly reserve SIGEXIT and SIGERR for ksh
    - [tg, izabera] Catch missing here documents at EOF even under “set -n”
    - [kre, tg] Document Austin#1015 handling (not considered a violation)
    - [tg, fmunozs] Fix buffer overread for empty nameref targets
    - [tg] Fix warnings pointed out by latest Debian gcc-snapshot
    - [tg, Martijn Dekker] Document upcoming set +o changes
    - [Martijn Dekker] Expand testsuite for command/whence
  * Remove now-irrelevant comment from debian/control
  * Update manpage from CVS incorporating lintian spelling fixes
  * Bump S-V (no changes needed); use SSL URIs for VCS (lintian)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 06 Mar 2016 22:03:50 +0100

mksh (52b-1) unstable; urgency=high

  * New upstream bugfix-only release:
    - [tg] Recognise ksh93 compiled scripts and LZIP compressed files
      as binary (i.e. to not run as mksh plaintext script)
    - [tg] Document that we will implement locale tracking later
    - [tg] Add EEXIST to failback strerror(3)
    - [jilles] Make set -C; :>foo race-free
    - [tg] Don’t use unset in portable build script
    - [tg] Plug warning on GNU/kFreeBSD, GNU/Hurd
    - [tg] Document read -a resets the integer base
    - [J�rg] Fix manpage: time is not a builtin but a reserved word
    - [J�rg, tg] Make exit (and return) eat -1
    - [tg] parse “$( (( … ) … ) … )” correctly (LP#1532621), Jan Palus
    - [tg] reduce memory footprint by free(3)ing more aggressively
    - [tg] fix buffer overrun (LP#1533394), bugreport by izabera
    - [tg] correctly handle nested ADELIM parsing (LP#1453827), Teckids
    - [tg] permit “read -A/-a arr[idx]” as long as only one element is
      read; fix corruption of array indicēs with this construct
      (LP#1533396), discovered by izabera
    - [tg] Sanitise OS-provided signal number in even more places
    - [tg] As requested by J�rg, be clear manpage advice is for mksh
    - [tg] Revert (as it was a regression) POSIX bugfix from R52/2005
      related to accent gravis-style command substitution until POSIX
      decides either way (Austin#1015) and upload with high urgency
    - [tg] Handle export et al. after command (Austin#351)
    - [tg] Catch EPIPE in built-in cat and return as SIGPIPE (LP#1532621)
    - [tg] Fix errno in print/echo builtin; optimise that and unbksl
    - [tg] Update documentation, point out POSIX violation (Austin#1015)
  * Only create /usr/bin/ksh compat symlink if needed (Closes: #807185)
  * Add missed changelog entries for upstream to 52-1 entry
  * Update debian/copyright and README.Debian

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 20 Jan 2016 23:03:23 +0000

mksh (52-1) unstable; urgency=medium

  * Remove parallel=* from DEB_BUILD_OPTIONS for the reproducible people
  * Add myself as Maintainer (Closes: #764401)
  * Make ed a Recommends (Closes: #803726)
  * Update text in README.Debian
  * Make .mkshrc alias-safe
  * New bugfix upstream release
    - [_0bitcount] Move moving external link from mksh(1) to the #ksh
      channel homepage linked therein
    - [tg] Make setenv “set -u”-safe and fix when invoked with no args
    - [tg] Make “typeset -f” output reentrant if name is a reserved word
    - [oksh] Zero-pad seconds in “time” output to align columns
    - [tg] Check signals and errorlevels from OS to be within bounds
    - [komh, tg] Quote and document ‘;’ as PATH separator in some places
    - [oksh, tg] Simplify code to call afree() even if arg is NULL
    - [tg] Fix tree-printing and reentrancy of multiple here documents
    - [tg] Work around LP#1030581 by permitting exactly one space after
    - [tg, oksh] Code quality work, cleanups
    - [tg] New code for here documents/strings with several bugfixes
    - [tg] Stop using issetugid(2) for ±p checks, wrong tool for the job
    - [tg] Reintroduce some -o posix changes lost in 2005, plus fixes
    - [tg] Make “source” into a built-in command
    - [tg] Drop “stop” alias, lksh(1) functionality to auto-unalias
    - [tg] Fix \u0000 ignored in $'…' and print
    - [tg] Improve portability of Build.sh
    - [Jilles Tjoelker] Improve portability of testsuite
    - [tg] Fix tilde expansion for some substitutions (izabera, Chet, Geoff)
    - [tg] Improve reparsing of ((…) |…) as ( (…) |…)
    - [Martijn Dekker] Fix test(1) not returning evaluation errors
    - [tg] Fix ${*:+x} constructs (carstenh)
    - [tg] Make (( … )) into a compound command (ormaaj)
    - [tg] Repair a few parameter substitution expansion mistakes
    - [tg] OpenBSD sync: handle integer base out of band like ksh93 does
    - [tg] Protect standard code (predefined aliases, internal code,
      aliases and functions in dot.mkshrc) from being overridden by
      aliases and, in some cases, shell functions (i.e. permit overriding
      but ignore it)
    - [tg] Implement GNU bash’s enable for dot.mkshrc using magic aliases
      to redirect the builtins to external utilities; this differs from
      GNU bash in that enable takes precedence over functions
    - [tg] Move unaliasing an identifier when defining a POSIX-style
      function with the same name into lksh, as compatibility kludge
    - [tg] Korn shell style functions now have locally scoped shell options
    - [tg, iSKUNK] Change some ASCII-isms to be EBCDIC-aware or pluggable
    - [tg, Ypnose] Mention lksh build instructions on manpage and website
    - [tg] Overhaul signal handling; support new POSIX NSIG_MAX, add
      sysconf(_SC_NSIG) as a later TODO item
    - [tg] Fix signal bounds (1 ≤ signum < NSIG)
    - [tg] Improve manual pages, especially wrt. standards compliance
    - [tg, iSKUNK] Initial EBCDIC work for dot.mkshrc
    - [tg, iSKUNK] Add list of z/OS signals to Build.sh
    - [tg] Work around the sh(1) backslash-newline problem by moving
      the code triggering it out of *.opt and into the consumers
    - [colona] Bind another well-known ANSI Del key in the Emacs mode
    - [tg] Fix ${foo/*/x} pattern checks, spotted by izabera
    - [carstenh] Fix error output of cd function in dot.mkshrc
    - [tg] read partial returns in -N and timeout cases
    - [tg] Fix $LINENO inside PS1; spotted by carstenh
    - [tg] Ensure correct padding of at least 2 spaces in print_columns
    - [tg] Note issues with nested complex parameter expansions and
      follow-up bugfixes to expect
    - [OpenBSD] Some language fixes in documentation; comments
    - [tg] Reimplement multi-line command history (Closes: #783978) + fixes
    - [Martijn Dekker] Fix command -v for “shell reserved words”
    - [tg] In dot.mkshrc make use of latest feature: local options
    - [tg] Fix ""$@ to emit a word
    - [tg] Change cat(1) hack to look first and not ignore builtin
    - [KO Myung-Hun] Begin porting mksh to OS/2
    - [komh, tg] Some generic minor bugfixes from OS/2 porting
    - [tg] Document mknod(8) isn’t normally part of mksh(1)
    - [tg] Quote arguments to : in build/test scripts as well
    - [tg] Add cat(1) hack for printf(1)-as-builtin: always prefer external
    - [tg] Explicitly use binary mode for any and all file I/O in stock mksh
    - [Ilya Zakharevich] Use termio, not termios(4), on OS/2
    - [tg] Set edchars to sane BSD defaults if any are NUL
    - [tg] Implement support for PC scancodes in Vi and Emacs editing mode
    - [komh] OS/2 uses ‘;’ as PATH separator plus support drive letters
    - [tg] Correct some mistakes in the manual page
    - [tg] Fix a bug in the testsuite driver, spotted on EBCDIC systems
  * Update “uhr” example
  * Bump debhelper as lintian demands
  * Update copyright file against code
  * Allow build without script(1), despite being Essential, due to #807071

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 12 Dec 2015 23:42:09 +0000

mksh (50f-2) unstable; urgency=medium

  * QA upload.
  * Build-depends on libklibc-dev [linux-any] instead of explicitly
    listing all linux architectures.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 03 Dec 2015 22:58:50 +0100

mksh (50f-1) unstable; urgency=low

  * QA upload.
  * The “adieu not au revoir” upload
  * Update to the next release of the R50-stable branch:
    - [tg] Add a patch marker for vendor patch versioning to mksh.1
    - [tg] Document some more issues with the current history code
    - [tg] Remove some unused code
    - [tg] RCSID-only sync with OpenBSD, for bogus and irrelevant changes
    - [tg] Also disable field splitting for alias 'local=\typeset'
    - [tg] Fix read -n-1 to not be identical to read -N-1
    - [tg] Several fixes and improvements to lksh(1) and mksh(1) manpages
    - [tg] More code (int → size_t), comment and testsuite fixes
    - [tg] Make dot.mkshrc more robust (LP#1441853)
    - [tg] Fix issues with IFS='\' read, found by edualbus
    - [enh, tg] Fix integer overflows related to file descriptor parsing,
      found by Pawel Wylecial (LP#1440685); reduce memory usage for I/O redirs
    - [tg] Document in the manpage how to set ±U according to the current
      locale settings via LANG/LC_* parameters (cf. Debian #782225)
    - [igli, tg] Some code cleanup and restructuring
    - [tg, oksh] Handle number parsing and storing more carefully
  * Merge changelogs for forgotten actual uploads:
    - mksh (28.0-3) oldstable (etch)
    - mksh (40.2-2exp1) experimental
  * Merge changelogs for potential uploads:
    - mksh (40.9.20120630-8) wheezy
    - mksh (50d-6) jessie
  * Improve /etc/skel/.mkshrc structure and make it “set -u”-safer
  * Remove the pdksh transitional package; document as NEWS entry
  * Tell users that only lksh (and mksh-static, for rescue systems,
    initramfs, etc.) should be used as sh; document as NEWS entry
  * Cosmetic improvements to README, control, build scripts, etc.
  * Use -DMKSH_SMALL_BUT_FAST when using -DMKSH_SMALL, as this
    benefits almost, if not all, Debian architectures
  * Upload to unstable

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 08 Jul 2015 21:27:51 +0200

mksh (50e-2) experimental; urgency=medium

  * QA upload.
  * Backport upstream fix:
    - [tg] SECURITY: make unset HISTFILE actually work
  * Adjust shell version accordingly

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 07 Mar 2015 23:30:36 +0000

mksh (50e-1) experimental; urgency=high

  * QA upload.
  * Remove timestamps from README.Debian; should make builds reproducible
  * Filter out some more junk from README.Debian
  * Update to the next release of the R50-stable branch:
    - [tg] Fix LP#1381965 and LP#1381993 (more field splitting)
    - [jilles] Update location of FreeBSD testsuite for test(1)
    - [Martin Natano] Remove dead NULL elements from Emacs keybindings
    - [tg, Stéphane Chazelas, Geoff Clare] Change several testcases for $*/$@
      expansion with/without quotes to expected-fail, with even more to come ☹
    - [tg] Fix miscalculating required memory for encoding the double-quoted
      parts of a here document or here string delimiter, leading to a buffer
      overflow; discovered by zacts from IRC
    - [RT] Rename a function conflicting with a MacRelix system header
    - [tg] Use size_t (and ssize_t) consistently, stop using ptrdiff_t; fixes
      some arithmetics and S/390 bugs
    - [tg] Remove old workarounds for Clang 3.2 scan-build
    - [tg] Remove all Clang/Coverity assertions, making room for new checks
    - [tg] Fix NSIG generation on Debian sid gcc-snapshot
    - [tg] Make a testcase not fail in a corner case
    - [tg] Fix issues detected by GCC’s new sanitisers: data type of a value
      to be shifted constantly must be unsigned (what not, in C…); shebang
      check array accesses are always unsigned char
    - [tg] Be even more explicit wrt. POSIX in the manpage
    - [tg] Fix shebang / file magic decoding
    - [tg] More int → bool conversion
    - [tg] Let Build.sh be run by GNU bash 1.12.1 (Slackware 1.01)
    - [Stéphane Chazelas, tg] Fix here string parsing issue
    - [tg] Point out more future changes in the manpage
    - [tg] Call setgid(2), setegid(2), setuid(2) before seteuid(2)
    - [tg] Fix spurious empty line after ENOENT “whence -v”, found by Ypnose
    - [tg] Optimise dot.mkshrc and modernise it a bit
    - [tg] Use MAXPATHLEN from <sys/param.h> for PATH_MAX fallback
    - [tg] Some code cleanup and warnings fixes
    - [tg] Add options -a argv0 and -c to exec
    - [jsg] Prevent use-after-free when hitting multiple errors unwinding
    - [tg] Fix use of $* and $@ in scalar context: within [[ … ]] and after
      case (spotted by Stéphane Chazelas) and in here documents (spotted by
      tg@); fix here document expansion
    - [tg] Unbreak when $@ shares double quotes with others
    - [tg] Fix set -x in PS4 expansion infinite loop
  * Update README, Description, copyright and build scripts
  * Upload to experimental due to the jessie pre-release freeze

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 01 Mar 2015 16:38:11 +0000

mksh (50d-6) jessie; urgency=medium

  * QA upload.
  * Backport upstream fix:
    - [enh, tg] Fix integer overflows related to file descriptor
      parsing, found by Pawel Wylecial (LP#1440685)
  * Adjust shell version accordingly

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 19 Apr 2015 22:27:16 +0200

mksh (50d-5) unstable; urgency=medium

  * QA upload.
  * Backport upstream fix:
    - [tg] SECURITY: make unset HISTFILE actually work
  * Adjust shell version accordingly

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 07 Mar 2015 22:16:53 +0100

mksh (50d-3) unstable; urgency=high

  * QA upload.
  * Update to CVS HEAD, the freeze is nearing, and this is better
    than the previous upload already anyway:
    - [tg] Add more tests detailing behaviour difference from GNU bash
    - [tg] Introduce a memory leak for x=<< fixing use of freed memory
      instead, bug tracked as LP#1380389 still live
    - [tg] Add x+=<< parallel to x=<<
    - [tg, ormaaj, jilles] POSIX “command” loses builtin special-ness
    - [tg] Begin fixing LP#1381965 and LP#1381993 (more field splitting)
  * Urgency again high because of POSIX compliance bugfixes (last two)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 23 Oct 2014 09:18:38 +0000

mksh (50d-2) unstable; urgency=high

  * QA upload.
  * Apply patch from LP#1381965

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 19 Oct 2014 19:57:24 +0200

mksh (50d-1) unstable; urgency=high

  * QA upload.
  * New upstream regression bugfix release:
    - [Goodbox] Fix NULL pointer dereference on “unset x; nameref x”
    - [tg] Fix severe regression in field splitting (LP#1378208)
    - [tg] Add a warning about not using tainted user input (including
      from the environment) in arithmetics, until Stéphane writes it up
  * Enable klibc builds on arm64 and ppc64el
  * Disable LTO build, it is still too unreliable
  * Orphan the package.

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 07 Oct 2014 17:21:21 +0000

mksh (50c-1) unstable; urgency=high

  * New upstream security release:
    - [tg] Know more rare signals when generating sys_signame[] replacement
    - [tg] OpenBSD sync (mostly RCSID only)
    - [tg] Document HISTSIZE limit; found by luigi_345 on IRC
    - [zacts] Fix link to Debian .mkshrc
    - [tg] Cease exporting $RANDOM (Debian #760857)
    - [tg] Fix C99 compatibility
    - [tg] Work around klibc bug causing a coredump (Debian #763842)
    - [tg] Use [197]issetugid(2) as additional check if we are FPRIVILEGED
    - [tg] SECURITY: do not permit += from environment
    - [tg] Fix more field splitting bugs reported by Stephane Chazelas and
      mikeserv; document current status wrt. ambiguous ones as testcases too
  * Policy 3.9.6, no changes
  * Use klibc on x32 again, to be binNMUable, and since it works good enough
  * Update lintian overrides

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 03 Oct 2014 18:56:34 +0000

mksh (50b-1) unstable; urgency=high

  * Bring back accidentally lost changelog entry for version 49-2
  * Note what was actually imported from CVS in the 50-4 changelog
  * Disable klibc builds on x32 for now, they’re essentially amd64
  * New upstream version; remaining change:
    - [tg, Jb_boin] Relax overzealous nameref RHS checks
  * Update /etc/skel/.mkshrc with example how to force UTF-8
  * Fix gitweb URL in README.Debian
  * Urgency high due to script regression since 50-1
  * Add NEWS entry for mksh script language changes in 50-1

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 03 Sep 2014 22:30:55 +0200

mksh (50-4) unstable; urgency=medium

  * The “Wollknäuel” upload, while preparing FrOSCon…
  * Update uhr to CVS HEAD, fixes a usage error
  * Update mksh to CVS HEAD, while here
    - [Ypnose] Fix operator description in the manpage
    - [tg] Change all mention of “eglibc” to “glibc”, it is merged back
    - [Colona] Fix rare infinite loop with invalid UTF-8 in the edit buffer
    - [tg] Make more clear when a shell is interactive in the manpage
    - [tg] Document that % is a symmetric remainder operation, and how to get
      a mathematical modulus from it, in the manpage
    - [tg, Christopher Ferris, Elliott Hughes] Make the cat(1) builtin also
      interruptible in the write loop, not just in the read loop, and avoid
      it getting SIGPIPE in the smores function in dot.mkshrc by terminating
      cat upon user quit
    - [tg] Make some comments match the code, after jaredy from obsd changed
      IFS split handling
    - [tg] Fix some IFS-related mistakes in the manual page
    - [tg] Document another issue as known-to-fail test IFS-subst-3
    - [tg] Improve check.pl output in some cases

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 22 Aug 2014 10:17:11 +0200

mksh (50-3) unstable; urgency=medium

  * Explicitly disable ProPolice SSP for dietlibc and klibc
    (the former already DTRT, but klibc doesn’t and breaks weirdly)
  * Change all mention of eglibc to glibc

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 04 Jul 2014 12:58:11 +0200

mksh (50-2) unstable; urgency=medium

  * debian/control: Move VCS-* fields to Alioth collab-maint git
  * Remove now useless RCS IDs; use upstream ones for files copied
  * debian/meat: Try LTO only for glibc builds (breaks klibc)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 03 Jul 2014 21:34:49 +0200

mksh (50-1) unstable; urgency=medium

  * New upstream version R50:
    - [tg] Fix initial IFS whitespace not being ignored when expanding
    - [tg] MKSH_BINSHREDUCED no longer mistakenly enables brace expansion
    - [tg] Explain more clearly Vi input mode limitations in the manpage
    - [tg] Improve error reporting of the check.pl script (which needs a
      maintainer since I don’t speak any perl(1), really), for lewellyn
    - [tg] Use $TMPDIR in test.sh for scratch space
    - [tg, Polynomial-C] Check that the scratch space is not mounted noexec
    - [pekster, jilles, tg] Use termcap(5) names, not terminfo(5) names, in
      tput(1) examples, for improved portability (e.g. to MidnightBSD)
    - [tg] Avoid C99 Undefined Behaviour in mirtoconf LFS test (inspired by
      Debian #742780)
    - [tg] Fix ${!foo} for when foo is unset
    - [tg] Improve nameref error checking (LP#1277691)
    - [tg] Fix readonly bypass found by Bert Münnich
    - [Ryan Schmidt] Improved system reporting for Mac OS X
    - [nDuff] Explain better [[ extglob handling in the manpage
    - [tg] Remove arr=([index]=value) syntax due to regressions
    - [tg] IFS-split arithmetic expansions as per POSIX 201x
    - [OpenBSD] Add more detailed Authors section to manpage
    - [tg] Fix set ±p issue for good: drop privs unless requested
    - [tg] Improve signal handling and use a more canonical probing order
    - [tg] Fix return values $? and ${PIPESTATUS[*]} interaction with
      set -o pipefail and COMSUBs
    - [enh] Detect ENOEXEC ELF files and use a less confusing error message
    - [tg] Update to Unicode 7.0.0
    - [tg] Shut up valgrind in the $RANDOM code
    - [tg] Use -fstack-protector-strong in favour of -fstack-protector-all
    - [tg] Fix access-after-free crash spotted by Enjolras via IRC

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 29 Jun 2014 13:17:35 +0000

mksh (49-2) unstable; urgency=medium

  * The “waiting for $customer_project to be ready” upload
  * Update to upstream CVS HEAD:
    - [tg] MKSH_BINSHREDUCED no longer mistakenly enables brace expansion
    - [tg] Explain more clearly Vi input mode limitations in the manpage
    - [tg] Improve error reporting of the check.pl script (which needs a
      maintainer since I don’t speak any perl(1), really), for lewellyn

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 31 Jan 2014 17:19:27 +0100

mksh (49-1) unstable; urgency=medium

  * The “10 years EarthCache” upload (well, I was busy yesterday)
  * Depend on klibc on x32 now that it is built
  * Adjust docs around octal numbers in arithmetics (Closes: #732509)
  * New upstream version R49:
    - [tg] dot.mkshrc: fix two issues with the cd wrapper
    - [tg] Unbreak set +p (wider issue still to be addressed)
    - [Steffen Daode Nurpmeso] Use WCONTINUED with waitpid(2)
    - [millert] Add proper suspend builtin handling tty(4) and setpgrp(2)
    - [tg] Sanitise and slightly optimise control character handling
    - [tg] Add O_BINARY to all open(2) calls for OS/2 kLIBC support
    - [tg] Generate option strings for shell, set, ulimit at compile time
    - [Steffen Daode Nurpmeso] Drop ISTRIP termios(4) mode
    - [tg] Mention negative history numbers, octals in the manpage
    - [tg] Make check.pl work with Perl < 5.6.1 again
    - [tg] Detect getsid(2) and skip the oksh suspend builtin otherwise
    - [tg] Document that set -o noclobber is unsafe for tempfiles
    - [tg] Update to Unicode 6.3.0
    - [RT] Restore some portability
    - [tg] Fix parsing positional argument variable names
    - [tg] Sprinkle a few __attribute__((__pure__)); fix warnings
    - [tg] Fix build on OSX: always use our wcwidth code; only use our
      strlcpy(3) code if the OE doesn’t provide one (prompted by jonthn
      on IRC)
    - [tg] Optimise sh -c to exec even in MKSH_SMALL
    - [tg] Use new BAFH for hashing
  * New upstream version R48b:
    - [tg] Fix display issue with multi-line prompts and SIGWINCH
  * New upstream version R48:
    - [tg] dot.mkshrc: unbreak hd(1) function in UTF-8 mode
    - [Jens Staal, tg] Improve buildability on Plan 9 and support kencc
    - [tg] Clean up and improve build process and testsuite
    - [Michael Langguth] Add multi-layer ICO file from mksh/Win32
    - [tg, Steffen Daode Nurpmeso] Fix interactive shell exiting on ^C or
      syntax error when the EXIT pseudo-signal trap was set (to anything)
      (Closes: #715533)
    - [tg, Daode] Display longer command excerpts in job control
    - [tg] Rewrite Emacs mode display window sliding calculation code
    - [tg] dot.mkshrc: “doch” now keeps standard input (requested by gecko2)
    - [tg] Reduce memory usage and improve comments and documentation
  * New upstream version R47:
    - [tg] Do not accidentally remove lksh.1 for in-srcdir builds
    - [tg] Fix post-build non-‘-Q’ output for lksh
    - [tg] Silence some configure-time warnings for clang-3.2 and GCC
    - [tg] Prevent recursion loops for namerefs; found by ormaaj
    - [tg] Replace wcwidth code by mine based on Unicode 6.2.0
    - [tg, Alexander Polakov] Fix quoting in word part of ${var+word} etc.
      when the expression is in a quoted brace or a here document
    - [tg] Fix some compiler warnings; improve sig{,handler}_t detection
    - [tg] Keep SIGCHLD blocked in some more semi-critical code paths
    - [tg] Fix uninitialised variable causing random nōn-numerical input
      to be accepted and acted upon in the select built-in command
    - [tg] No longer chown(2)/chmod(2) the -T tty(4) argument
    - [tg] Don’t fork(2) if the -T tty(4) argument begins with ‘!’;
      eliminates the need for things like oneit_line/cttyhack/etc. on Linux
    - [jca] Fix “for var in; do” to not be interpreted as “for var; do”
    - [tg] Use %zu for printing size_t (ipv %lu with casting around)
    - [tg] use ${SIZE-size} for lewellyn’s cross
    - [fgsch, espie, millert, tg] Write more testcases
    - [millert] POSIX specifies that for && and || lists, only the exit
      status of the last command matters for “set -e”; fix and document
    - [millert] check.pl: Add -T flag to set the tmpdir; use mkstemp(3)
      and mkdtemp(3) instead of $$ in /tmp for tempfiles
    - [jca] Make $(<nonexistent) behave like $(cat nonexistent)
    - [tg] Let shf_open return an errno; display why file wasn’t read
    - [tg] Finally decide on regression-39 desired outcome (sync with
      AT&T ksh93 and GNU bash --posix as well as mksh behaviour)
    - [tg] Fix post{in,de}crement in not evaluated side of e.g. ternary
      operator (LP#1187729)
    - [tg] Fix “set -x” problems; add “set +o inherit-xtrace” (LP#1179287)
    - [tg] Simplify some code
    - [tg] Fix segfault related to mixing funsub/valsub and comsub
  * Policy 3.9.5 (no changes required)
  * Fix lintian warnings

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 11 Jan 2014 19:09:42 +0000

mksh (48b-0) unstable; urgency=low

  * The “International Geocaching Day” not-upload

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 17 Aug 2013 22:57:38 +0000

mksh (48-0) unstable; urgency=high

  * The “waiting for GCC and klibc to be fixed” not-upload

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 15 Aug 2013 00:15:42 +0200

mksh (46-2) unstable; urgency=low

  * The “Universal OS – freedom of choice” upload
  * Update to latest upstream CVS HEAD; changes:
    - [tg] Do not accidentally remove lksh.1 for in-srcdir builds
    - [tg] Fix post-build non-‘-Q’ output for lksh
    - [tg] Silence some configure-time warnings for clang-3.2 and GCC
  * Prepare lksh for being used as /bin/sh (with printf builtin);
    put into NEWS.Debian instruction to change the symlink
  * Drop printf builtin from mksh and mksh-static (they can still
    be used as /bin/sh but that brings back #532324; cf. #539158)
  * Update README.Debian and package Description accordingly
  * Write a message to buildd admins, to keep the chroot up-to-date
    (and remind them of the /dev/tty and /dev/ptmx necessities),
    to the build log
  * Make the localedef failure warning message more clear

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 22 May 2013 19:25:38 +0000

mksh (46-1) unstable; urgency=low

  * The “Omas” upload
  * Update to latest upstream stable release; changes:
    - [tg] dot.mkshrc: prevent lksh from running it
    - [tg] Add the lksh manual page to the mksh distribution
    - [tg] Make both lksh and mksh interpret numbers with a leading
      digit zero (‘0’) as octal precisely iff “set -o posix” is active
    - [tg] Point out the octal digit and the integer arithmetic differences
      from POSuX verbosely in the manual pages (point people who need
      octals to “set -o posix” and who need longs to lksh) and elaborate
      on the horrors of ISO C Undefined Behaviour which is allowed to
      delete all your data
    - [tg] Unbreak “set -o” (list flags) in lksh on LP64 machines
    - [tg] Implement Emacs mode PgUp as Vi insert mode Cur↑ for Yofuh
    - [tg] Allow setting both “set -o sh” and “set -o posix”, if done in the
      same command; shuffle around compatibility levels (mksh/lksh, with
      -o sh, with -o posix) again; permit a /bin/sh to set either or both
    - [tg] Sync lksh manual page with the exact code ifdefs
    - [tg] Change more use of signed integer to use unsigned instead
    - [tg] Implement “set -o pipefail” like AT&T ksh93 and GNU bash do
    - [tg] dot.mkshrc: provide hd(1) in Pure mksh™ for fallback
    - [tg] Implement VALSUBs (value substitutions): ${|REPLY=foo;}
  * Let /bin/sh use both -o posix and -o sh for better standards compliance
  * Improve README.Debian

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 02 May 2013 23:01:38 +0000

mksh (45-1) unstable; urgency=low

  * New upstream stable release; changes:
    - [tg] Make “set -x” print the commands run in escaped form
    - [tg] PS4 in dot.mkshrc is now timestamped
    - [tg] The &> GNU bash I/O redir is no longer parsed in -o posix,
      -o sh modes, lksh (breaks valid scripts)
    - [tg] Implement ${ …;} more efficiently (deleted-open files)
    - [tg] For shf, %#s (if you can get it past GCC’s printf format attribute)
      calls print_value_quoted, ignoring field width and precision
    - [tg] Catch “typeset =” (regression) with better error message
    - [tg, Tonnerre Lombard] add “doch” alias to dot.mkshrc which just repeats
      the last input line with sudo(8)
    - [tg] Use unsigned integers for all calculations, to avoid ISO C
      “Undefined Behaviour” (and implementation-defined behaviour) throughout
      (most of) the code; emulate signed integer arithmetics using unsigned;
      not-lksh only
    - [tg] Emulate signed modulo naïvely, for correct sign of the result
    - [tg] Add <<< and >>> for ROL and ROR (rotate left and right,
      respectively) operations, <<<= and >>> assignments; bitwise AND the RHS
      of a shift/rotate op with 31 (not for lksh)
    - [tg] Remove a warning by working around a workaround found in dietlibc
      which works around a bug in broken software such as GNU tar (really!)
    - [tg] Correct and simplify list and categorisation of built-in commands
      as POSIX special and “everything else” plus a flag to keep assignments
    - [tg] Handle ((foo)) as “let]” internally to avoid a conflict with user-
      defined functions called let (LP#1156707)
    - [tg] Clean up the code
  * Upload to unstable

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 26 Apr 2013 22:23:42 +0000

mksh (44-1) experimental; urgency=low

  * New upstream stable release; changes:
    - [tg] "$@" always generates words; bug spotted by engla in IRC
    - [tg] Optimise print_columns display to use the screen space better

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 05 Mar 2013 17:07:37 +0000

mksh (43-1) experimental; urgency=medium

  * New upstream stable release; changes:
    - [tg] Do not permit $'…' and $"…" in anything that looks like a
      string, as old scripts, like  ncurses’, depend on behaviour not
      guaranteed by POSIX regarding unescaped dollar signs there
    - [dalias] Make detection of function prototypes more reliable
    - [tg] Quote setenv arguments for eval properly in dot.mkshrc
    - [tg] Validate parameter names for typeset, export, etc.
    - [tg] Provide a classic BSD echo builtin for /bin/sh on MidnightBSD
    - [tg] When generating Makefrag.inc put list of check_categories inside
    - [tg] Actually test all echo(1) flavours and MidnightBSD /bin/sh hacks
  * Updated “Uhr” example script

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 19 Feb 2013 19:11:41 +0000

mksh (42b-1) experimental; urgency=medium

  * The “Acetylsalicylsäure++” upload
  * Drop B-D on pax, not really needed since I was forced to
    switch to full debhelper for 40.9.20121124-2 again
  * Add linux-libc-dev to B-U for klibc as it uses kernel headers
    (don’t do something similar for kFreeBSD or Hurd: unnecessary)
  * Merge changelog for upload: mksh (40.9.20120630-7) unstable
  * Use upstream .orig.tar.gz files unchanged
    - printf.c lives in debian/ now, symlinked in the CVS packaging
      repo ⇒ change meat to copy over for building
  * Simplify rules and watch files accordingly
  * New upstream must-have bugfixes stable release:
    - LP#1104543 fix was too strict (Closes: #700526)
    - Correctly initialise memory (Closes: #700604)
  * Add linux-libc-dev to “dependencies” output, too (see above)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 15 Feb 2013 23:37:12 +0000

mksh (41.9.20130210) experimental; urgency=low

  * The “remedies for frustration – bzr lessons-learned” upload
  * Debian-relevant changes from R41-stable branch:
    - Fix getn and some cases of possible array bounds trespasses
    - Fix “command shift”, reported by «ormaaj:#!/bin/mksh»
    - Fix regression wrt lists in functions and “set -e” (LP#1104543)
  * Update to mksh CVS HEAD; Debian-relevant changes:
    - Fix ${ precmd;} in dot.mkshrc to retain the errorlevel
    - Prefer const-clean sys_errlist[] to strerror(3)
    - Permit $"…" and $'…' everywhere except in the body of here
      documents that are not here strings
    - Use full recursive parser for double-quoted here strings,
      and reuse code between here strings and here documents
    - #ifdef DEBUG_LEAKS free all fds and memory on exit (LP#1106116)
    - Don’t close stdout/stderr with redirections, dup /dev/null instead,
      always, both in dot.mkshrc and the testsuite, it does break!
    - Handle ${ …;} like functions in that local and return DWIW;
      use it for the big chunk in $PS1 to avoid fork(2)ing (at cost of
      tempfiles; dot.mkshrc is a sample, adjust to your needs)
  * Merge changelog for upload: mksh (40.9.20120630-5) unstable

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 11 Feb 2013 14:41:10 +0100

mksh (41.1-6) experimental; urgency=low

  * Brown paperbag upload
  * Fix traps for “set +e”, too (Really Closes: #696823)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 01 Jan 2013 22:25:40 +0000

mksh (41.1-5) experimental; urgency=low

  * The “huh an m68k buildd is more fun than manual scheduling” upload
  * Update to otherwise unpatched head of mksh R41-stable branch:
    - [tg, RT] Bunch of portability and build system fixes
    - [tg] Fix running the ERR and EXIT traps in situations with set -e
      and possibly eval (Closes: #696823)
  * Update dot.mkshrc to CVS HEAD to have ${ precmd;} again
  * Add my Uhr as contributed example of what to do with mksh ;-)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 01 Jan 2013 21:31:41 +0000

mksh (41.1-4) experimental; urgency=low

  * The “maybe amd64 buildd chroot got upgraded by now…” upload
  * Update to head of mksh R41-stable branch:
    - fix mistake in hash collision resolution implementation

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 08 Dec 2012 19:05:46 +0000

mksh (41.1-3) experimental; urgency=low

  * The “waiting for clang-3.2 to pass NEW” upload
  * Update to head of mksh R41-stable branch:
    - we use -fno-asynchronous-unwind-tables for GCC now
    - some warning fixes, mostly -Wsign-compare

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 05 Dec 2012 20:06:09 +0000

mksh (41.1-2) experimental; urgency=low

  * The “Geier” upload (keep in experimental for now)
  * New upstream formal stable release; changes:
    - [tg] Fix an input command line editing display redrawing issue
    - [tg] Track the tty to keep $COLUMNS and $LINES up-to-date after
      a SIGWINCH even in scripts
  * Update to mksh R41-stable branch:
    - buildsystem warning fixes
    - fixes for issues discovered by LLVM+Clang scan-build
  * Update debian/watch file: distfiles are .tgz now
  * debian/meat: Fix $CC invocation for B-U generation and be more robust

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 04 Dec 2012 01:38:13 +0000

mksh (40.9.20121124-2) experimental; urgency=low

  * The “other littlest” upload
  * Redo packaging to use debhelper again (Closes: #690381)

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 26 Nov 2012 18:11:39 +0000

mksh (40.9.20121124-1) experimental; urgency=low

  * The “Marek” upload, to experimental, people please test test test!
  * New CVS snapshot:
    - [tg] Make dot.mkshrc usable with “set -o nounset” / “set -u”
    - [tg, Clint Adams] Clean up and optimise the error handling code
    - [tg] Fix and add some checks in the testsuite
    - [tg] Sort list of variables in the source code when possible
    - [tg] Add $BASHPID (for ormaaj) and $MKSH_UNIXTIME
    - [tg] Improve documentation, #ksh IRC channel homepage
    - [tg, RT] Minix 2 also doesn’t have gettimeofday(2) ⇒ check for it
  * Fix mailing list reference in lksh(1) manpage
  * Policy 3.9.4: introduce Built-Using header

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 24 Nov 2012 13:20:41 +0000

mksh (40.9.20121030-1) experimental; urgency=low

  * The “cnuke” upload, to experimental (for testing the changes by users)
    - TODO: bump S-V and introduce Built-Using header, now that it
      is (finally) standardised
  * New CVS snapshot:
    - [tg] Apply speed improvements and add MKSH_SMALL_BUT_FAST
    - [tg] Make quoted output of “typeset -p” AT&T ksh93 compatible
    - [tg] Implement ${foo@Q} like ${foo:Q} in make(1)
    - [tg] Remove some unused code; more int → bool conversion
    - [tg] Fix ulimit builtin usage to match what limits we actually know
    - [tg] Allow overriding /etc location, experts only (LP: #1039713)
    - [tg, Todd Miller] Avoid changing ps(1) output by accident
    - [tg, ft, Christian Neukirchen] Detect zsh 2.5.02/NeXTstep for Build.sh
    - [tg] Detect musl-gcc wrapper, define _BSD_SOURCE there, which is totally
           bogus, but musl, just like dietlibc, gets it wrong
    - [tg] Improve compile-time assertions
    - [tg] Repair select builtin without any choices given
    - [tg] Add -DMKSH_GCC55009 hack to avoid some compile-time assertions and
           introduce arith-mandatory in check.t to substitute for missing that
           compile-time check; will change (related to LP#1058035)
    - [tg] Rewrite lots of code to not rely on -fwrapv so much
    - [tg] Build.sh: Fix flock(2) detection on GNU/Linux
    - [Andrew Kudryashov] Manpage: fix default for HISTSIZE
    - [tg] Add debugging aid (split-screen mechanism using GNU screen)
    - [Andrew Kudryashov] Manpage, Website: point out correct mailing list
    - [tg, Andrew Kudryashov] Fix ~/nonexistant tab completion
    - [tg] Optimise sh -c “[^]\t\n"-$&-*;-?[\\|]*” to exec, inspired by
      Jilles Tjoelker (-DMKSH_DISABLE_EXPERIMENTAL to ostracise)
    - [tg] Fix $? inside eval (RedHat BZ#865121)
    - [tg] Implement ksh93 feature ${ foo;} (second attempt, exclude with
      -DMKSH_DISABLE_EXPERIMENTAL, using tempfiles this time), but do not
      use it in dot.mkshrc yet (until stable)
    - [tg] Run SIGINT check more reliably in the cat builtin (LP#1058815)
    - [tg] Handle ^C in here documents, COMSUB, arith (Closes: #691116)
  * Bump versioned B-D on libklibc-dev [armhf] to known-fixed
  * In .mkshrc, read /etc/debian_chroot if necessary, like GNU bash

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 30 Oct 2012 21:15:13 +0000

mksh (40.9.20120630-8) wheezy; urgency=medium

  * Backport upstream fix:
    - [tg] SECURITY: make unset HISTFILE actually work
    - [enh, tg] Fix integer overflows related to file descriptor
      parsing, found by Pawel Wylecial (LP#1440685)
  * Adjust shell version accordingly

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 19 Apr 2015 22:22:13 +0200

mksh (40.9.20120630-7) unstable; urgency=low

  * The “customer service” upload
  * Correct the fix for LP#1104543 (Closes: #700526)
  * Fix uninitialised memory access (Closes: #700604)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 15 Feb 2013 19:00:40 +0000

mksh (40.9.20120630-6) unstable; urgency=low

  * Revert the fix for LP#1104543 as it causes Debian #700526
    (not closing as it’s not a proper fix)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 15 Feb 2013 17:44:20 +0000

mksh (40.9.20120630-5) unstable; urgency=low

  * Bump versioned B-D on libklibc-dev [armhf] to known-fixed
  * Fix input command line editing display redrawing issue
  * Backport fixes to the regression testsuite and some new tests
  * Add bugfixes for error handling related issues:
    - behaviour of $? in eval (RedHat BZ#865121)
    - running the EXIT and ERR traps (Closes: #696823)
    - set -e vs. use of &&/|| in a function (LP#1104543)
  * Add appropriate regression tests for these fixes
  * Update the mailing list address in lksh.1 manpage
  * In /etc/skel/.mkshrc handle /etc/debian_chroot like bashrc does
  * Update copyright year

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 11 Feb 2013 14:14:37 +0100

mksh (40.9.20120630-4) unstable; urgency=low

  * The “Cookie” upload
  * Revert Debian derivate from Canonical that cannot be named-specific
    change to drop dietlibc B-D
  * Bump versioned B-D on dietlibc-dev [armhf] to known-fixed

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 13 Oct 2012 14:56:50 +0000

mksh (40.9.20120630-3debianderivatethatcannotbenamed1) quantal; urgency=low

  * The “GNU Chagrin Collection” upload
  * Merge from Debian unstable.  Remaining changes:
    - Remove dietlibc-dev build-deps, unnecessary for Debian derivate that cannot be named.
  * Move some compile-time checks to run-time (LP#1058035)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 29 Sep 2012 22:00:14 +0000

mksh (40.9.20120630-3) unstable; urgency=low

  * The “PHP Securiwhat?” upload
  * Apply cherry-picked fixes from mksh CVS (branch mksh-wheezy):
    - Upgrade to Unicode 6.1.0
    - Plug memory leak in tab completion code
    - Fix tab completion for tilde, related to LP#1025843
    - Fix reentry of here documents (LP#1030581)

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 03 Sep 2012 19:28:19 +0000

mksh (40.9.20120630-2) unstable; urgency=low

  * The “kutweer” upload
  * Apply cherry-picked fixes from mksh CVS (branch mksh-wheezy):
    - [tg] Fix CONSERVATIVE_FDS use-before-definition bug
    - [tg] Correct a regression when tab-completing (LP#1025843) and fix
      bugs in the same code wrt. completion display and other expansions
  * Document use of CONSERVATIVE_FDS in lksh manpage

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 20 Jul 2012 23:32:37 +0000

mksh (40.9.20120630-1) unstable; urgency=low

  * The “GC2TDN7” upload
  * Update to mksh CVS HEAD for manpage string improvements
  * Point to IRC and mailing list in the lksh manual page
  * Drop redundant -DMKSH_NO_LIMITS in klibc builds
  * Mention /etc/skel/.mkshrc in the pdksh upgrade message
  * Bump pdksh versioned dep on mksh, to have complete changelog
  * Rework some more texts and hints
  * Say hello to debianderivatethatcannotbenamed main, pdksh is gone

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 30 Jun 2012 17:30:11 +0000

mksh (40.9.20120628-1) unstable; urgency=low

  * The “meet a deadline” upload
  * Update to mksh-HEAD:
    - [tg] Legacy mksh: use “long”, not “int32_t”, for arithmetics
    - [tg] Legacy mksh: allow dummy set ±o emacs, gmacs, vi, …
    - [tg] fix trimming with positional parameters (Closes: #48453)
    - [tg] ensure that case end tokens are not mixed up (Closes: #220272)
    - [tg] make alias definitions in mksh -c work (Closes: #517009), hack
  * Show note about login shell transition in postinst (Closes: #679322)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 28 Jun 2012 22:44:00 +0200

mksh (40.9.20120626-2) unstable; urgency=low

  * The “So long, and thanks for all the fish!” upload
  * Transition /usr/share/doc/pdksh to a symlink manually,
    as dpkg won’t do that for us (thanks Robert Luberda)
  * Disabling ProPolice/SSP for klibc’s a bit tricky, fix

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 27 Jun 2012 07:16:03 +0000

mksh (40.9.20120626-1) unstable; urgency=low

  * The “popcorn!” upload
  * Forgot in 40.9.20120518-2 to set $CC correctly when cross-building
  * By request of pdksh maintainer take over the pdksh binary package
    and make it transitional
  * Update to mksh-HEAD:
    - [tg] Fix some issues found by Coverity and some found while fixing
    - [tg] Build.sh options: -t target-filename (instead of mksh);
      -L to build a legacy mksh, current changes:
      > different $KSH_VERSION “LEGACY KSH” instead of “MIRBSD KSH”
      > purely for running ksh88 and pdksh scripts; no command line editing
      > use traditional “set -- $(getopt …); echo $?” mode always
      > do not keep file descriptors private
      > parse leading-zero-digit numbers as octal
      > no mksh extension -T
  * Write an lksh(1) manual page
  * Make build process better error-resistent

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 26 Jun 2012 21:12:43 +0000

mksh (40.9.20120518-2) unstable; urgency=low

  * The “what’s a bit or hurd hacking compared to m68k reviving” upload
  * Enable dietlibc and klibc on as many targets as possible, even any
    version not positively known to break the mtests, in debian/control
    and switch debian/meat to paranoia (shy of freeze) mode to use only
    eglibc unless the testsuite is allowed to be run
  * Also rebuild against the new klibc release 2.0
  * Use debhelper-less package build system
  * TODO: Add Built-Using header once that is documented

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 07 Jun 2012 00:26:49 +0000

mksh (40.9.20120518-1) unstable; urgency=low

  * The “lots of bugfixing” upload
  * Update to mksh-HEAD:
    - [tg] Fix some bugs in Build.sh
    - [tg, ciruZ] Switch from NZAT to NZAAT hash for better range
      coverage; turns out that the never-zero property of NZAT was
      not in fact needed for hash tables as implemented in mksh
      (also, align, and 75% are enough)
    - [tg] Add MKSH_NO_CMDLINE_EDITING, MKSH_DISABLE_TTY_WARNING
    - [RT] Port to Coherent UNIX
    - [tg] Enable some options by default for some ports, for
      instance, since BeOS can never have a controlling tty, the
      option disabling that warning
    - [tg] Some bugfixes, prompted by RT and Valgrind
    - [RT] Disable sigsuspend(2) on Syllable Desktop
    - [tg] Fix several issues with typeset -p (LP: #993847)
    - [tg, RT] Detect lcc, klibc
    - [tg] Check for klibc sigsuspend fix
    - [RT] Apply inline fix for lcc, e.g. with libc5
  * Require klibc again (sigsuspend availability is now checked)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 18 May 2012 16:53:35 +0000

mksh (40.9.20120414-3) unstable; urgency=high

  * The “I could probably use pause() instead” upload
  * Disable klibc except for a positive-list of architectures that
    are using RT signals already, due to non-RT sigsuspend brokenness
  * Drop m68k specific klibc workaround (it’s the above)
  * Urgency high as mksh-static is subtly broken on many platforms

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 05 May 2012 21:42:09 +0000

mksh (40.9.20120414-2) unstable; urgency=low

  * The “still more buggy than I had hoped” upload
  * When running mtests, time-limit every test to prevent hanging builds
  * Add back ppc64, packages.d.o brokenness had me fooled
  * m68k specific klibc workaround: -g but no -O are needed (gcc bug?)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 14 Apr 2012 18:48:37 +0000

mksh (40.9.20120414-1) unstable; urgency=low

  * The “ziek zĳn zuigt” upload
  * d/source/format 3.0 (quilt), with local single-debian-patch
  * Honour DevRef §6.7.8.2.(4) wrt. top-level directory name
  * Base on mksh-current HEAD of today:
    - [tg] New Build.sh environment configurable: LDSTATIC (empty)
    - [tg] Improve LTO effect by always adding our copies of distributed
      utility function sources when linking statically (i.e. LDSTATIC is
      not empty)
    - [tg] Drop deprecated hack for lines beginning with an exclamation mark
    - [tg] No longer interpret numbers beginning with a 0 digit as octal
    - [tg] Attempt to use -fwrapv on more compilers
    - [tg, RT] Better portability to 386BSD
    - [tg] No longer use mkstemp(3) or tempnam(3) functions, do our own
    - [tg] Fix some bugs in the manual page
  * Try klibc and fix missing optimisation for size with it
  * Note klibc and dietlibc both disable ProPolice SSP

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 14 Apr 2012 16:58:58 +0000

mksh (40.5-3) unstable; urgency=low

  * The “Basti” intermediate upload
  * Add a minitest that select(2) works (fails on dietlibc/ppc64)
  * Patch up to mksh-current HEAD of today:
    - [tg, RT] Implement fcntl(2)-based advisory locking as an
      alternative iff flock(2) is not found (LP: #912691); keep
      trying to lock in the face of EINTR on OSes that throw it
    - [tg] Improve testsuite, build-time checks and debugging output
    - [tg, RT, winstonw] Improve portability to BeOS (broken),
      Cygwin (good), SCO OpenServer (good), SCO UnixWare (good),
      USL C, Plan 9 (broken), …
    - [tg] rlim_t is supposed to be unsigned
    - [tg] Some code and warning cleanup
  * Revert the 40.5-2 dietlibc test change as promised

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 29 Mar 2012 19:35:09 +0000

mksh (40.5-2) unstable; urgency=low

  * The “meow korn shell” upload
  * We build on DEB_BUILD_ARCH for DEB_HOST_ARCH, not the other way round,
    take this in mind when deciding based on the target system (DEB_HOST)
  * Add hotfix for regression in 40.5 wrt. tty initialisation handling
    - [tg] Fix severe regression wrt. initialising tty(4) states
  * Build-Depend on newer dietlibc upload for testing that (will be
    removed in the next upload when 40.6 is out); if needed, we can
    always block the 40.5-1 upload from entering testing
  * Build with --as-needed

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Mar 2012 20:34:46 +0000

mksh (40.5-1) unstable; urgency=low

  * The “amused” upload
  * Patch up to mksh R40-stable branch of today:
    - [tg, RT, lewellyn] Better support for SkyOS, Minix 3, Ninix 3,
      QNX and various BSD/OS versions
    - [tg] Fix regression in mirtoconf output wrt. cached values (introduced
      with check if divmod fixup was needed)
    - [tg] Drop some Android-specific unused code (lsmod builtin)
    - [tg] More code cleanup and new developer-only debugging functions
    - [tg, Andrew Kudryashov] Fix some tab completion related escaping bugs
    - [tg, draenog] Honour COLUMNS and LINES from the environment in scripts
    - [tg, winstonw] The sleep built-in utility now blocks more signals
    - [tg] Warn when using another deprecated function that will be removed
  * New upstream distfile from the above
  * Patch up to mksh-current HEAD of today:
    - [tg] Drop “set ±o arc4random” (deprecated in R40)
    - [tg] Drop old Build.sh -long-options (deprecated in R40)
    - [tg] Change the internal hash algorithm from Bob Jenkins’ one-at-a-time
      to its NUL-counting, always-changing, never-zero, better-avalanching
      MirOS variant NZAT
    - [tg] Use $'…' for non-ASCII parameters for re-entry printing
    - [tg] Use sane spelling of “read-only” consistently
    - [tg] Improve tree -DDEBUG functions (internal/developer use)
    - [tg] Reduce stack usage a bit; speed up hash tables at size cost
    - [tg] MKSH_SMALL no longer implies -fno-inline
    - [tg] Support optional seed in ${parameter@#seed} for security
  * Consider yourself warned about the following things:
    - once klibc ships mkstemp() we will build mksh-static against it
    - soon, probably before the wheezy freeze even, we will disable
      deprecated code (which users of are warned about, at the moment)
  * Policy 3.9.3 (no relevant changes)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 24 Mar 2012 23:30:11 +0000

mksh (40.4-3) unstable; urgency=low

  * The “sleepy” upload
  * Several fixes for klibc support:
    - dpkg-buildflags adds -fstack-protector, klibc doesn’t like it
    - on m68k, klibc builds need -g or they croak
    - unbreak overriding which toolchains are used for mksh-static
  * Patch up to mksh R40-stable branch of today:
    - [tg, RT] Move mirtoconf checks and INCLUDES_ONLY parts of sh.h
      around to ensure prerequisites are always available
    - [tg, RT, ir0nh34d] Pass mksh.exe to testsuite, if such thing is
      generated, and deal with Cygwin passing just “mksh” in argv[0] in
      such cases
    - [tg] Imply -DMKSH_ASSUME_UTF8=0 on MSYS; optimise checks
    - [tg, Jb_boin] Fix regression introduced in R35b by jaredy’s
      security patch where TTIME trashed a non-TCOM string argument
      (e.g. in TFOR)
    - [tg] Better support for tcc; fix GCCism that accidentally crept in
    - [tg] Deal with UTF-8 when reporting jobs’ commands
  * Omit dietlibc and don’t depend on lsb-release on hppa, to give
    it some chances to catch up (and mark for revisiting)
  * Note that mksh-static has some features disabled in the package
    description (unless DEB_BUILD_OPTIONS contains nomksh-small)
    ‣ do we want to have a dynamically generated binary package desc?
  * Copyright year is now 2012

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 11 Feb 2012 16:59:31 +0000

mksh (40.4-2) unstable; urgency=high

  * The “busy” upload
  * Patch up to mksh R40-stable branch of today:
    - [tg, Jilles Tjoelker] skip readonly check in unevaluated ternary twig
    - [tg, anonymous] fix all remaining ifs.sh testcases
    - [tg] No longer try to build with GCC and C99 extensions
    - [tg, Jilles Tjoelker] Do not expand aliases in COMSUB twice
    - [tg] Honour UTF-8 multi-byte character boundaries when doing partial
      tab-completion insertions (LP: #909025) to fix RedHat BZ#745702
    - [tg] Fix R40 (BZ#496791) regression with IOACT in TIF (LP: #907224)
    - [tg, ft] Darn persistent history code worst offenders (LP: #906914)
    - [tg] Fix some gc-sections, GCC and Clang/scan-build warnings/issues
    - [tg, 28C3] dot.mkshrc hash functions: partially address LP: #909818
    - [tg] Only compile divmod(0x80000000, -1) code in when not unneeded
  * Merge from the squeeze and lenny-hardy backport packages:
    - The “dreaming of aufsbuilder” upload
    + Document that, even in all backports, the debconf questions for
      /bin/sh handling are now gone
    - The “motivated” upload
    + d/control: lsb-release is only needed on hppa at the moment
    + d/README.Debian: rework note on /bin/sh use for backports
  * Urgency high due to the severity of the assorted bugfixes

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 31 Dec 2011 02:53:56 +0000

mksh (40.4-1) unstable; urgency=low

  * The “not-so-little-any-more brother” upload
  * Update to mksh R40d (release):
    - [tg, Jilles Tjoelker] test(1) built-in behaves exactly as POSIX says
    - [tg] Move compile-time assertions to Build.sh from misc.c#ifdef DEBUG
    - [tg] Invocation documentation is at the bottom of Build.sh
    - [tg] test.sh: verbosely look for perl(1) interpreter to use
    - [tg] New tests for integers (base 1‥36, base unspecified, base OOB)
    - [tg] Correct error paths for typeset -n global state
    - [tg] Deprecate interpreting "010" as octal number, will go
    - [tg] Improvements re. integer handling; more explicit manpage text
    - [tg] Do not use caddr_t on Linux, so dietlibc stops bitching
    - [tg, Jilles Tjoelker] Catch division/modulo overflow 0x80000000/-1
    - [tg] Emacs mode ^O regression fix when the fetched lines are edited
  * Add missing upstream code change explanations to the changelog
    entries 40.3-1, 40.2-5, 40.2-4 (in lieu of upstream-changelog)
  * Fix two oversights that might (finally) get us line-buffered I/O
  * Disable use of <libutil.h> to avoid needing to B-C libbsd-dev
  * Use hardening=+all in DEB_BUILD_MAINT_OPTIONS querying buildflags
  * mtest.t: new brkcontin to catch breakage failing test.sh operation
  * Also, scan the test log and fail the build if the testsuite
    appears not having run at all (Closes: #651615)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 11 Dec 2011 18:51:39 +0000

mksh (40.3-1) unstable; urgency=medium

  * The “Missing” upload
  * Update to “mksh R40c+”, snapshot of R40-stable branch:
    - [tg] Fix R40 regression misparsing $(case x in (x) :; esac)
    - [tg] New test.sh ‘-f’ option (same as ‘-C fastbox’)
    - [tg] Drop using set -o noglob inside pushd/popd/dirs
    - [tg] Use += more in dot.mkshrc and keep strings shorter
    - [tg] Correct interworking between local and set -A
    - [tg] Fix out-of-bounds memory access on strings of 32 KiB length
    - [tg] MKSH_DISABLE_DEPRECATED (for integrators)
  * debian/.mkshrc: proper ksh88-hack char extraction and reuse
  * debian/rules: use dh_prep ipv “dh_clean -k” iff it exists,
    ONLY to please the new build log checker not taking backport‐
    friendliness of packages into account
  * Use more loose dietlibc-dev build dependencies again, except
    on known-bad cases (armel armhf s390) and need-verification
    cases (no build logs available yet: hppa sparc64) and new
    arches (s390x) but not on those where _some_ intermediate
    versions were bad but both old and new versions work and the
    testsuite falls back to eglibc if broken (powerpc sparc)
  * Update package description - pdksh is orphaned, suggests mksh
  * Log toolchain versions in buildinfo

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 26 Nov 2011 19:28:57 +0000

mksh (40.2-5) unstable; urgency=low

  * The “Fernet-Branca” upload
  * debian/rules: cleanup (remove dh_installdirs)
  * debian/.mkshrc: use $'…' for PS1, like dot.mkshrc now does
  * Use new-style template for maintainer scripts (good comments)
  * Update to mksh R40-stable from today, which is close to R40c
    - [RT, Chris “ir0nh34d” Sutcliffe] Port to MSYS
    - [tg, Markus Duft, Bruno Haible] Interix select(2) bug workaround
    - [tg] Manpage fixes
    - [tg] Deprecate the “command line begins with ‘!’ for fc -e -” hack
    - [tg] Promote x=(a b); x+=(c d) to a core mksh(1) feature
    - [tg] Testsuite fixes for Hurd, MSYS; warning fixes for dietlibc
  * Build-Depend on today’s dietlibc to test-drive it, again

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 19 Nov 2011 22:48:44 +0000

mksh (40.2-4) unstable; urgency=low

  * The “visit us at OpenRheinRuhr” upload (AllBSD *and* Debian/m68k!)
  * Pull in mksh packaging CVS HEAD, to test-drive packaging changes
    (also gives us back PIE, relative to the last experimental upload,
    and tries dietlibc on both MORE and ALL architectures possible)
  * To also test dietlibc, version its B-D (this upload is not
    intended to be released with wheezy, there _will_ be another
    one before it, but it is needed to get dietlibc into shape
    for the wheezy and precise releases, and it delivers a fix)
  * Pull mksh CVS commit 1004EB9A7F80119200E, which fixes setting
    the base of several built-in integer parameters to 10 instead
    of retaining the one from the first assignment (regression)
    - [tg] Fix accidental behavioural change wrt some built-in parameters
  * Upload to unstable, despite the test status (also, this will
    not migrate to testing anyway, due to #633479)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 11 Nov 2011 22:50:09 +0000

mksh (40.2-3exp1) experimental; urgency=low

  * Expand dietlibc-dev B-D to armhf hppa and depend on experimental
    version, to test-drive that
  * Disable PIE hardening for now, until compiler bugs are addressed

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 09 Nov 2011 11:21:51 +0100

mksh (40.2-3) unstable; urgency=low

  * The “What a wonderful… day (or week?)” upload
  * Avoid warnings during build information logging
  * Update to R40-stable branch from 2011-10-25 23:00 for:
    - [jonthn, Snader_LB] Fix spelling mistakes
    - [cnuke] Fix bugs spotted during porting to OPENSTEP
    - [tg, jg71] Unbreak building stristr with MKSH_ASSUME_UTF8 defined
    - [tg] Fix most of the issues Jerker Bäck encountered on Interix
    - [tg] Wrap access(2) as it may return false positive for X_OK on root
    - [OpenBSD] Upper bound Emacs mode command repeat by input line length
    - [tg] Improve CPPFLAGS mangling in Build.sh
    - [Snader_LB] Several comment, documentation and website fixes/updates
    - [tg] Avoid identifiers and cpp(1) macros with two underscores in a row
      and those with a trailing underscore; they are reserved for the OS
  * Add “hardening=+pie,+bindnow” when calling dpkg-buildflags; reminded by
    RichiH (release goal); drop PIE for mksh-static (non-PIC obviously)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 25 Oct 2011 23:25:17 +0000

mksh (40.2-2exp1) experimental; urgency=low

  * The “I’ve just had some Kruškovac❣” upload
  * Build-Depend on the version of dietlibc in experimental and
    upload to experimental, to test the former

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 18 Sep 2011 20:09:57 +0000

mksh (40.2-2) unstable; urgency=medium

  * The “Someone bring me Kruškovac❣” upload
  * Update to R40-stable branch from 2011-07-26 17:30 for:
    - [tg, Wouter Verhelst] Fix <tt>${foo%\?}</tt> in <tt>-o sh
  * This makes mksh as /bin/sh not break on building d-i on m68k
  * Mention that mksh-small makes a faster /bin/sh on slow arches
  * Drop the mksh-as-/bin/sh debconf code and questions from the
    package in preparation for Goswin’s fix for that dash bug;
    drop our /bin/sh diversion, always

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 26 Jul 2011 21:41:01 +0000

mksh (40.2-1) unstable; urgency=low

  * debian/meat: Fix running the testsuite on Hurd
  * Do not call "update-alternatives --remove" on upgrade (cf. #568299)
  * New upstream stable version “Frankenheim Alt”:
    - [tg] Don’t busy-loop on nameref ARY=ARY (LHS = RHS)
    - [tg, yofuh] Tabcomplete ~foo like $FOO (LP: #710539)
    - [tg] Code cleanup, style, and minor assorted fixes
    - [tg] Tabcomplete ~foo/M↹ (with slash) economically
    - [tg] Add new [DEL: experimental :DEL] global builtin, doing the same
      as local (typeset, really – but that doesn’t deserve its name) does,
      except localising all parameters it touches
    - [tg] Better error messages with non-integral environment imports
    - [tg] $RANDOM environment import accepts any string now
    - [tg, Lucas Holt] Add setenv cshism to dot.mkshrc
    - [tg, Johannes] Allow ^C to interrupt the built-in cat(1)
    - [tg, Arkadiusz Miśkiewicz, Kacper Kornet] Fix mksh taking down the
      entire terminal, hard, when scripts use $COLUMNS and fork off utilities;
      regression introduced in mksh R37 (sorry, no regression test possible)
    - [tg, Arkadiusz Miśkiewicz] Properly mark need-ctty regression tests
    - [tg] MKSH_NO_EXTERNAL_CAT – Quell the external cat(1) calls magic
    - [tg, Arkadiusz Miśkiewicz] Yes, “echo” is not portable, document
    - [tg] Improve content and look of the manual page
    - [tg] Move /etc/{,suid_}profile to /system/etc/ on Android
    - [tg] Prevent more compiler warnings; catch build errors earlier
  * Build from R40-stable branch: get a fix for dot.mkshrc

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 25 Jul 2011 16:38:45 +0000

mksh (40.1-1) unstable; urgency=medium

  * README.Debian: Log check_categories to use with the testsuite
  * debian/meat: Restore skipping of catmanpage build
  * This is “Frankenheim” mksh R40:
    - [tg] Let code samples in check.t and dot.mkshrc take care of the
      new features; fix some longstanding bugs in them
    - [tg] Add missing flush in rewritten read builtin for prompting
    - [tg] Minix builds now automatically disable the ulimit builtin
  * Medium urgency due to the missing flush call (problematic UI)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 12 Jun 2011 17:52:42 +0000

mksh (40~0.20110605-2) unstable; urgency=low

  * Upgrade to mksh R40 Release Candidate 3
    - [tg] [hash table limit]; work around bug in GCC 4.1 on Debian Etch
    - [tg] New -c lto option to use Link Time Optimisation (GCC) with
      automatic fallback to -c combine if unavailable
    - [tg] Improvements for -c dragonegg, -c llvm (with gcc+dragonegg,
      or llvm-gcc and clang, respectively), and TenDRA
  * Enable LTO, for real, this time

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 05 Jun 2011 20:47:53 +0000

mksh (40~0.20110604-1) unstable; urgency=low

  * Do not use libbsd any longer, mksh is self-contained
  * Update README.Debian, copyright
  * Upgrade to mksh R40 Release Candidate 2
    - [tg, hondza] Fix regression in tab completion result display
    - [tg, Frank Terbeck] Fix parsing x=(…) expressions
    - [tg, Jb_boin] Increase hash table limit; don’t crash when reaching it
    - Comment sync with OpenBSD ksh
    - Update testsuite tags (for Cygwin and other weird platforms)
  * Catch early build failures better

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 04 Jun 2011 20:15:03 +0200

mksh (40~0.20110529-1) unstable; urgency=low

  * Update to mksh R40 Release Candidate from CVS:
    - [tg, Kacper Kornet] Implement a new regression test attribute
      need-pass: {yes|no} and exit 1 if unexpected fails occur
    - [tg] Add ;& and ;| for case
    - [tg] Rewrite the read builtin and its documentation; adding
      -A (read IFS words into array), -a (read octets/wide characters
      into array), -N/-n (read only / up to z bytes), -t (read with
      timeout)
    - [tg] Add -e option to cd -P (POSIX 2011)
    - [tg] Update dot.mkshrc to use the new features
    - [tg] Fix gsf’s ifs.sh tests of the read builtin
    - [tg, cnuke] Improve support for AIX, Cygwin, IBM XL C
    - [tg] Add tests for x+=(y z) and ;;& extensions
  * Please help testing this, so the release can rock❣

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 29 May 2011 18:51:43 +0200

mksh (39.3.20110506-1) unstable; urgency=low

  * New CVS snapshot with more regression and bug fixes:
    - [tg] Correct skipping the UTF-8 BOM when identifying a file
    - [tg] Do not use <stdbool.h> any longer
    - [tg] Use double-underscore-framed __attribute__s
    - [tg] Always catch SIGALRM (for the sleep builtin)
    - [tg, wbx] Functions now inherit a global set -x
    - [tg] Do not explicitly initialise static globals to 0/NULL
    - [tg] Eliminate some dead code (functions, globals)
    - [tg] Correct more tree handling bugs and merge similar code
    - [tg] Add “+=” to concatenate scalars and append to arrays
    - [tg] Support empty here document delimiters
    - [Robert Luberda] Fix the four-argument form of test(1)
      (Closes: #465250) – patch and testcases taken from pdksh.deb
    - [tg] Drop the pre-POSIX ability to “test -t” without specifying “fd”
    - [tg] Defer dropping an alias in favour of a POSIX function to
      when the function is actually defined and check for the closing
      parenthesis too
  * Drop armhf dietlibc dependency, it’s broken
  * Drop hppa dietlibc dependency, there’s no known good version
  * Shorten debian/rules; update package description (mksh HEAD is
    at OpenBSD 4.9-current level)
  * Policy 3.9.2 with no changed relevant to us

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 07 May 2011 01:16:22 +0000

mksh (39.3.20110328-2) unstable; urgency=high

  * Turns out running history-subst-4 on the buildds is a bad idea…
    revert, and just live with the bug on hppa for now
  * Urgency as this fixes FTBFS from 39.3.20110328-1 which was high

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 28 Mar 2011 23:26:13 +0000

mksh (39.3.20110328-1) unstable; urgency=high

  * Back out dietlibc [hppa] dependency on experimental package
    to be able to upload to unstable
  * New CVS snapshot fixing all known regressions from the
    recent experimental changes, as well as some more fallout:
    - [tg] Fix mis-detection of gcc format attribute (false negative)
    - [tg] Include some Android specific hacks (no change on other OEs)
    - [tg, Jb_boin] In ${foo/bar/baz} expressions, when adjourning empty
      patterns to avoid running into a busy-wait loop, remember to skip
      the anchor characters (‘#’ or ‘%’) at the beginning, yet keep the
      special meaning replacing a string begin or end with a string has
    - [tg] Write a pattern optimiser that is run internally before calls
      to the pattern matching code always (currently, replaces a@(b@(c)d)e
      with abcde but keeps @(a|a), then (in a second pass) collapses
      adjacent asterisk (‘*’) wildcards into a single one; this fixes some
      of the symptoms of severe performance issues our pattern matching code
      has to the extent that it can prevent busy-looping (found by Jb_boin)
    - [tg, Chris “ironhead” Sutcliffe, Chet Ramey, Eric Blake, David Korn]
      Handle pathnames with exactly two leading slashes well (SUSv4 3.266)
    - [tg, Wayne Pollock, Bart Schaefer] Fix here documents, add testcases
    - [tg] Fix corner case ${##1}, add tests for that and ${##} and ${#?}
    - [tg] Bring back “test -H” ifdef S_ISCDF (for HP-UX) from pdksh
    - [tg] Align read-only variable behaviour with (future) POSIX
    - [tg] Permit ${foo%(*} on FSH (Debian Closes: #619947)
    - [tg, rsc] Allow skipping testcases that need a controlling tty
  * High urgency because the fix for ${foo%(*} is required since without
    it, keyboard-configuration=1.68+squeeze2 can fail to configure
  * Copy history-subst-4 to mtest.t to ensure hppa mksh-static is usable
  * Tweak build process to prevent more redundant checks
  * On unattended Hurd builds, skip testcases that need a controlling tty

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 28 Mar 2011 22:26:25 +0000

mksh (39.3.20110313-1) experimental; urgency=medium

  * New CVS snapshot:
    - [tg] Use the existing state machine, a recursive parser and retracing
      the input stream for correct x=(…$((…$(…)…))…) parsing
    - [tg, Jb_boin] complain about ${x:1:2:3} instead of crashing
    - [tg, Jb_boin] make optional printf(1) builtin __CRAZY=Yes clean and
      prevent it from crashing by reading past end of (invalid) format strings
    - [tg] abort(3) on rogue pointers #ifdef DEBUG
    - [tg] Correct some documentation, code commentary, etc.
    - [tg] Handle the UTF-8 Byte Order Mark in $(…) expressions
    - [tg] Speed up reading input by checking for the BOM only once
  * Urgency due to crash (SIGSEGV, glibc-malloc corruption) fixes

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 13 Mar 2011 17:06:35 +0000

mksh (39.3.20110308-2) experimental; urgency=low

  * Update architecture list for dietlibc (in experimental)
  * Depend on fixed hppa dietlibc (from experimental)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 08 Mar 2011 21:03:53 +0000

mksh (39.3.20110308-1) experimental; urgency=low

  * Fix build warnings
  * Add mtest-ascii1 to catch an unclear dietlibc bug on mips, powerpc
  * New CVS snapshot:
    - [tg] Port to MiNT / FreeMiNT (Atari m68k operating system)
    - [tg] Do not close filedescriptor #3 (controlling tty) on UWIN
    - [tg] Make the tree printing code safe for re-entrancy of output
    - [tg] Implement recursive parser for $(…) to fix RedHat BZ#496791
    - Note that MKSH_NOPROSPECTOFWORK disables |& (co-processes)
  * Upload to experimental (happy birthday, you three)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 08 Mar 2011 19:37:05 +0000

mksh (39.3.20110218-3) unstable; urgency=medium

  * Fix build when GNU bash in /bin/sh (still no idea _why_ though)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 04 Mar 2011 11:54:20 +0000

mksh (39.3.20110218-2) unstable; urgency=medium

  * When cross-compiling (DEB_{BUILD,HOST}_GNU_TYPE not the same)
    set mksh-firstbuilt to avoid “testing” non-native executables
  * mksh can do Multi-Arch: foreign as requested by vorlon
  * Install build information (actual compiler, flags, regression
    testsuite results, etc.) and regression testsuite as documen‐
    tation files (append build info to README.Debian)
  * Fix bug which resulted in always trying to build with combine
  * README.Debian: /bin/mksh-static can be /bin/sh too
  * README.Debian: Add notes about expected testsuite failures

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 03 Mar 2011 20:38:48 +0000

mksh (39.3.20110218-1) unstable; urgency=low

  * New CVS snapshot:
    - [tg] Limit history file size to 1 GiB for sanity
    - [tg] Add smores, a more(1)-like pager, as shell function to
      dot.mkshrc (not control character safe but tty aware)
    - [tg, David Korn] Make builtins directly callable; utf8-mode is
      determined by LC_ALL/LC_CTYPE/LANG environment variables in that case
    - [tg] If the interactive shell uses setlocale(3)/nl_langinfo(3)
      to divine utf8-mode, fall back to environment variables unless success
    - [tg] When called as a builtin, echo(1) behaves POSIXish
    - [tg] Replace some MirBSD utilities with links to mksh(1) and ensure
      some integration to keep compatibility
    - [tg] Add a microsecond capable sleep(1) builtin
    - [tg] Add selftest-direct-builtin-call regression test
    - [tg] If the built-in cat is invoked from a direct builtin call, it
      now properly handles the POSIXly demanded ‘-u’ option (as a no-op)
    - [tg] Support the PIPESTATUS array (like GNU bash)
  * Rewrite packaging to automatically test for usable libraries
    (klibc (not yet) or dietlibc, fallback to eglibc) for mksh-static
    and better test whether the binaries built against them is usable
  * Try dietlibc on PowerPC, S/390, sparc again (we test the binary)
  * Bring back basic klibc support (can be enabled by DEB_BUILD_OPTIONS)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 19 Feb 2011 17:36:19 +0000

mksh (39.3.20110209-1) unstable; urgency=low

  * New CVS snapshot:
    - [tg, Jörg-Volker Peetz] Emacs prev-hist-word resets the counter
      if other editing commands were run in between; repeat calling
      works, even together with arguments, now; arguments are 0-based
      (Debian Closes: #603801) – now for real ☻☺
    - [tg] Fix mis-sign comparison and potential truncation error
  * Support $debian_chroot in /etc/skel/.mkshrc (template)

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 09 Feb 2011 13:30:29 +0000

mksh (39.3.20110203-1) unstable; urgency=low

  * New CVS snapshot:
    - [tg] More int → bool conversion, whitespace and related code cleanup,
      error messages and typo correction
    - [tg] Don’t alias suspend on Android either (goes together with stop)
    - [tg] dot.mkshrc no longer exports $PS1, as recommended by Frank Terbeck,
      to avoid confusing other shells
    - [tg] The character width table is now in sync with Unicode 6.0.0
    - [tg] MKSH_SMALL doesn’t imply HAVE_REVOKE=0 any longer
    - [tg] Ignore a ‘$’ preceding ‘"…"’ (like bash, ksh93)
    - [tg] Make “foo=<<EOF” a direct assignment of here document (or here
      string) to string variable
    - [tg] Add KSHEGID, KSHGID, KSHUID variables (idea from Richard K.)
    - [tg] Option -d to read specifies a delimiter, like ksh93 (10x Dave)
    - [tg] Extension ${foo@#} expands to hash of $foo (mksh specific)
    - [tg] Emacs prev-hist-word now resets the counter if other functions
      were called in between (Debian Closes: #603801)
    - [tg] Introduce MKSH_NOPROSPECTOFWORK which implies MKSH_UNEMPLOYED
      and additionally disables job signals, sigprocmask(2), etc.
    - [tg] POSIX: trap 'echo foo' UNKNOWN is not a syntax error
    - [tg] Do not use <sys/file.h> unless it exists
    - [tg] dot.mkshrc: When we set a UTF-8 locale (e.g. for the GNU OS),
      we must also set -o utf8-mode to match it
    - [tg] Don’t append a space after tab-completing a parameter substi-
      tution that doesn’t contain a glob/extglob (LP: #710539)
  * add RCS IDs into more files
  * d/README.Debian: be more explicit about mksh-as-/bin/sh and
    mention we wait on klibc, to use it with mksh-static
  * d/control: add note on dietlibc B-D, which can be dropped
    e.g. if porting to Derivates that don’t have it, like UCS
  * d/control: update long description
  * d/copyright, d/rules: we use debian/rules get-orig-source" now
  * d/copyright: sync, 2011
  * d/rules: restructure a bit; add build-{indep,arch} targets
  * d/rules, d/x_getflag: use dpkg-buildflags if existent
  * d/po/it.po: update translation, grazie TetsuyO!
  * run debconf-updatepo

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 03 Feb 2011 18:38:45 +0000

mksh (39.3.20101101-1) unstable; urgency=low

  * New CVS snapshot:
    - [tg] In setres{u,g}id/setuid EAGAIN case, error out immediately
    - [OpenBSD] Some small manpage fixes
    - [tg] Clean up mirtoconf and build warnings with some compilers
    - [tg] Fix \c? vs. \c~ mis-documentation in mksh(1)
    - [tg] Remove the somewhat-portable setmode.c from the mksh source
      distribution and demote mknod(8) to an optional builtin, disabled
      by default, manually re-enabled in the installer only on MirBSD
    - [tg] Regenerate wcwidth table from Unicode 6.0.0
    - [tg] Change behaviour of argument-less exit in traps to match SUSv4,
      original patch from Jonathan Nieder (Debian Closes: #599484)
  * Integrate Vietnamese translation update, thanks Clytie Siddall
    (Closes: #601925)
  * Use lsb-release instead of dpkg-vendor for better reliability

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 16 Nov 2010 13:42:18 +0000

mksh (39.3.20100915-1) UNRELEASED; urgency=high

  * New CVS snapshot:
    - [Jeff Hamilton] Don’t alias stop on Android (system specific conflict)
    - [tg] Add size optimisations, ifdef’d, mostly for Android
    - [tg] Address what few concerns Chris Palmer (Android security team) had:
      check all multiplications and some additions for integer overflows,
      mostly in allocation context, and check setres{u,g}id/setuid for EAGAIN
      iff the target OS is known to be returning it (Linux only, right now)
    - correct a regression: 「read i?'foo:'」 was not working

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 16 Sep 2010 22:03:08 +0000

mksh (39.3.20100905-1) UNRELEASED; urgency=low

  * New CVS snapshot:
    - [tg] More int → bool conversion, whitespace and related code cleanup
    - [tg] Improve mksh(1) manpage coverage, remove mentions of not-mksh
    - [tg] Use wcwidth() from system on MirBSD
    - [tg] u_int32_t is no longer needed (only for OpenBSD’s pre-ISO-C99
      arc4random API, which we no longer call), so don’t provide it from
      Build.sh any longer
    - [tg, tonnerre] Scan for uint8_t and provide if not found
    - [tg] Fix realpath builtin for “/file/” arguments wrt. POSIX
    - [tg] Do not generate <stdint.h> from Build.sh as file any more if
      it is missing; rather let sh.h define the types appropriately and
      fix related compiler warnings
    - [tg] Add “cat” builtin (defers to external if options are given)
    - [tg] Reduce size by improved string pooling
    - [tg] Document 「x=$(eval $(cat)) <<'EOF'」 workaround for the $(…)
      parsing bug in the mksh(1) manual page and on the Red Hat Bugzilla
    - [tg] Add support for handling a “--” argument to more builtins
    - [tg] Correct some error messages
  * Move extra/printf.c.1.nn to debian/extra/printf.c for improved
    compatibility with source/format 3.0 and reduced build warnings
  * Build with -Wall -Wextra in all modes
  * Mention where strict aliasing warnings in dietlibc mode come from

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 05 Sep 2010 21:04:15 +0000

mksh (39.3.20100725-1) unstable; urgency=high

  * The “Portability?” release
  * Another new CVS snapshot:
    - [tg] More int → bool conversion
    - [tg] Fix window size not being checked during runtime
      of external programmes by not relying on SIGWINCH so
      much but instead checking before every interactive
      editing of a command line
  * High urgency because 39.3.20100721-1 isn’t yet in testing
  * Policy 3.9.1.0, no changes needed

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 29 Jul 2010 08:54:25 +0000

mksh (39.3.20100721-1) unstable; urgency=high

  * The “WTF is up with all these bugs spotted?” release
  * Another new CVS snapshot:
    - [tg] Fix NULL pointer dereference during iteration loop
      when checking for alias recursion; discovered by Michal
      Hlavinka
  * High urgency due to SIGSEGV crashes

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 21 Jul 2010 11:48:24 +0000

mksh (39.3.20100719-1) unstable; urgency=high

  * New CVS snapshot; summary of changes relevant to Debian:
    - [tg] Correct shf buffer I/O routines to avoid a memory
      corruption bug discovered by Waldemar Brodkorb and other
      bad effects (bug inherited from pdksh, anno 1999)
  * High urgency due to memory corruption and “set -x” fix

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 19 Jul 2010 22:51:03 +0000

mksh (39.3.20100717-1) unstable; urgency=low

  * The “「Don't drink and dupload ;-)」? I use dput anyway!” release
  * debian/rules: revert change disabling -combined on dietlibc,
    since it appears to be of no practical relevance
  * debian/rules: disable dietlibc on sparc due to weird problems
  * debian/rules: adapt build log scanner contraband to newer gcc
  * Switch from patch system to applying patches directly to the
    extracted source in “1.0” style (in the future, “3.0 (quilt)”
    can ease this) by using repackaged orig.tar.gz
  * Install upstream’s dot.mkshrc as /etc/mkshrc and source this
    from a new, minimal, /etc/skel/.mkshrc (debian/.mkshrc); idea
    by Michal Hlavinka (RHEL package maintainer)
  * Use repackaged upstream snapshot; changelog:
    - [tg] Remove arc4random(3) functionality; seed an LCG depending
      on the OS doing Address Space Layout Randomisation; speed up
    - [tg] Fix spelling in dot.mkshrc
    - [tg] Implement “live” window resize for the Emacs editing mode
    - [tg] More fixes for bugs found by Valgrind and LLVM+Clang scan-build
    - [tg] For script compatibility support “set ±o arc4random” during a
      transition period until R40 is out (but issue a warning to stderr)
    - [oksh] Add (, ), (( to reserved words in the manual page and fix
      some formatting errors with GNU groff’s mdoc
    - [tg] Make printf.c.1.15 use mksh’s shf_* routines instead of stdio
    - [tg] Fix -Wc++-compat except implicit casts from/to "void *"
  * Update printf.c file added; the new version actually uses mksh’s
    shf functions instead of libc stdio, saves about 11K in mksh-static
  * Adapt debian/* to new versions
  * Bump Standards-Version to 3.9.0.0 (no changes required)
  * Remove experimental, commented-out, klibc support for readability
  * Run debconf-updatepo; put something into Language: header lines
  * Lintian P: mksh: maintainer-script-without-set-e config

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 17 Jul 2010 23:27:41 +0000

mksh (39.3-4) unstable; urgency=low

  * debian/control, debian/rules, debian/mksh.install{,.in}:
    improve klibc builds (still disabled) and, for testing
    purposes, do full, dynamic, builds if klibc is enabled
  * debian/diffs/backport-fixes.diff: replace with upstream CVS diff
    between 39.3 and 20100522 and adjust manpage version number; changes:
    - [tg] Make default temporary directory configurable at compile time
    - [tg] Fix performance deficiencies in the built-in realpath function
    - [tg] Deprecate Build.sh -longoptions in favour of short ones:
      -valgrind becomes -g (like debug), -combine and -llvm become
      -c {combine,llvm} and the LLVM optimiser flags are passed via
      -O = -o -std-compile-opts
    - [tg] New Build.sh options -c dragonegg (for using the LLVM plugin
      to GCC 4.5 with inter-module optimisation), -v (version)
    - [tg] Document another way to get a coloured PS1 in the manpage
    - [tg] Disallow some more kinds to trim a vector; Closes: #581867
    - [oksh] Simplify some code; RCSID and comment sync with OpenBSD ksh
    - [oksh] Apply diff from manuel giraud to keep track of LINENO in a trap
  * Silence some build log checkers wrt. false positives triggered from
    mirtoconf output (affects both Debian and Debian derivate from Canonical
    that cannot be named, at least)
  * Put upstream changes for 39.3-2 and 39.3-3 into debian/changelog
    entries retroactively for proper documentation
  * debian/rules (if Debian derivate from Canonical that cannot be named):
    Exclude dietlibc on powerpc/ppc64 and sparc
  * debian/rules: the “diet” wrapper also eats most of our CFLAGS when
    passing them to cc, so disable combine mode there to avoid some of
    the problems, such as strict aliasing violations that are none
  * debian/control: prefer pax over cpio

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 24 May 2010 15:09:22 +0000

mksh (39.3-3) unstable; urgency=medium

  * debian/diffs/backport-fixes.diff: replace with upstream CVS diff
    between 39.3 and 20100420 and adjust manpage version number;
    this fix unbreaks word splitting "${foo#a}" for foo="a b c",
    which, for example, is used by kwalletcli
    - [tg] Fix "${x#?}" expansion when quoted, for real this time

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 20 Apr 2010 09:21:39 +0000

mksh (39.3-2) unstable; urgency=low

  * README.Debian: mention /etc/skel/.mkshrc
  * debian/diffs/backport-fixes.diff: replace with upstream CVS diff
    between 39.3 and 20100409 and adjust manpage version number; changes:
    - [tg] Correct small mistakes in manpage and build script
    - [ahoka, tg, stippi, bonefish] Port to Haiku (and probably, implicitly,
      BeOS; this is not tested though)
    - [tg, stippi] Add Haiku specific RLIMIT_NOVMON as ‘V’ to ulimit builtin
    - [tg] Let Build.sh cope with dirname(1) unavailability
    - [tg] In the Emacs editing mode, hi-bit7 octets are now considered
      “motion characters” for word boundaries – Esc+b, Esc+f, ^W, …
    - [tg] Make EXECSHELL default configurable at compile time (embedded)
    - [tg] If MKSH_SMALL do not compile in “set -o bgnice” by default
    - [tg] Rework how RLIMIT_{AS,RSS,VMEM} map to ‘m’ and ‘v’ ulimits
    - [tg] Add some more OS specific limits seen in zsh
    - [tg] SUSv4 ${v=a\ b} and "${v=a\ b}" and ${v-a\ b} compliance, tests
    - [tg] Make "~/.mkshrc" path configurable at compile time (embedded)
    - [tg] Fix SUNWcc 12.1 error message scan in build phase=u
    - [tg, Johannes Sixt, Geoff Clare] Fix variable assignment scope during
      command execution (expansion vs. assignment execution environment);
      [Herbert Xu, Geoff Clare] Add more regression tests for this
    - [tg] Fix single quotes in "${foo#bar}" (differs from "${foo-bar}")
    - [oksh] Fix mknod(8) usage message: b|c are not optional
    - [tg, oksh] Fix "${x#?}" expansion when quoted (quotes, space)
  * debian/control: make locales optional on avr32
  * debian/rules: disable locale support on avr32

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 09 Apr 2010 20:08:16 +0000

mksh (39.3-1) unstable; urgency=low

  * New upstream version R39c; shortened ChangeLog since R39:
    - [tg] Build system, code, docs and testsuite cleanup, also style(9)
    - [tg] Parse and evaluate ${parameter op word} correctly
    - [tg] Fix possible SIGSEGV in interactive mode bind builtin due to
      mis-optimisation of gcc combined with a bogus prototype;
      discovered by Grml.org's Frank Terbeck (ft), thanks!
    - [tg] Clean up some more strict *roff or compiler warnings: dashes,
      undefined macros; casting errors (constness, signedness, type
      width/class) and catch possibly unaligned pointer dereferences
      early; remove code/rodata redundancies, plug memory leaks
    - [smultron] Tweak the manual page: point out the word “colour”
    - [tg] Optimise dot.mkshrc DJB’s CDB hash implementations; add Bob
      Jenkins’ one-at-a-time hash (standard and leading-bit
      initialised); fix signedness in expressions; let the hashes use
      stdin if "$*" is empty, like Lb64{en,de}code; use
      “[[ -o utf8-mode ]]” ipv “[[ $- = *U* ]]”
    - [tg] Build.sh portability fixes: missing prerequisite headers;
      ensure $CC is never called without $CFLAGS; fix test.sh, et al.
    - [tg] Optimise internal variable representation; use one-at-a-time
      hash; cache hash values for faster resizing at zero memory cost;
      clean up hash table (keytab) code; switch hash table collision
      resolution algorithm to Python’s; prepare for later changes
    - [tg] Fix type errors in the source code (int → bool, size_t,
      mksh_uari_t)
    - [tg] Fix “${foo:bar:$baz}” not working (missing substitute() call)
    - [tg] Implement “typeset ±a” as nop
    - [tg] Support ksh93-like “${!foo[@]}” listing the keys (indicēs) of
      all set array elements
    - [tg] Support bash/ksh93-like “array=([key]=value …)” and
      (additionally) “set ±A array -- [key]=value …” to directly
      specify indicēs to use
    - [tg] Document the optional, unsupported, printf(1) builtin in TFM
    - [tg] Replace realpath(3) dependency and internally used
      get_phys_path() pdksh code with own implementation; always offer
      the realpath builtin
    - [tg] Implement nameref='typeset -n' (bounded variables) like AT&T
      ksh93 but with mksh-style nested/dynamic scoping and on-use
      resolving; they cannot currently be stored in an array though
    - [tg] Add “chdir” builtin doing the same as “cd” special builtin
    - [tg, David Korn] Document more differences between mksh (and
      pdksh) and AT&T ksh (or, more specific, ksh88, ksh93) in the
      manual page
    - [tg] Support “'a'” as an alternative to “1#a”, like ksh93 does
    - [tg] Add ksh’s “test -o ?foo”: true if “foo” is a valid shell
      option, where “foo” can be “xtrace” or “-x” or “+x” (these three
      are equivalent)
    - [tg] Support “$'…'” backslash-expanding single-quoted strings, as
      requested by David Korn, with almost the same syntax and semantics
    - [tg] Unify backslash expansion code (C style vs. print builtin)
    - [tg] Support “function stop () {” bashism
    - [tg] For several items in the source code that require order to be
      kept, provide from multiply-included header files; sort correctly
    - [tg] Get rid of unneeded FMONITOR (-m) for shells without job
      control; sync list of flags, comments and manpage with reality
    - [tg] If MKSH_SMALL, reduce size by removing editor functionality
    - [tg] Support VT100 emulator style {Ctrl,Alt}-CurLeft/Right keycode
      sequences with new vt100-hack emacs bind function (LP: #355883)
    - [cnuke, tg] Remove more, like GNU bash extensions, from MKSH_SMALL
    - [tg] Remove more functionality, such as Emacs command line editing
      mode bind key macros, and other extensions, from MKSH_SMALL to
      help floppies
    - [tg] Make forking and subshells less expensive wrt. random state
    - [tg] Build and source code fixes for / caught by SUNWcc, HP aCC,
      pcc, DEC ucode cc (MIPS), GCC, LLVM clang
    - [tg] Make undef/def MKSH_NOVI into 0/1 MKSH_S_NOVI build flag
    - [tg] Get rid of "U getenv" in nm output, we already import environ
    - [tg] Simplify $RANDOM handling: reads are now either arc4random(3)
      (if available: set +o arc4random is no longer possible) or an LCG;
      writes are arc4random_pushb(3) if available for explicit writes,
      arc4random_addrandom(3) otherwise, or another one-at-a-time hash
      feeding the LCG; furthermore, RANDOM is now always exported to and
      imported from (implicit read: no push to kernel done) the
      environment vector on startup and spawning
    - [tg] Document mksh does not exactly use OPTU-8/OPTU-16 in the
      manpage, as well as when characters, octets, or screen columns
      are used
    - [tg] Fix exit 127 on "mksh /tmp/horsies" ipv of 1 on ENOENT,
      #548744
    - [Clint Adams] Fix typos in the testsuite
    - [tg, Clint Adams] Begin a shared testsuite for mksh and posh
    - [tg] Make 「((foo) || bar)」 and 「((foo) | (bar))」 work
    - [tg] Fix lazy evaluation of assignments by ternary operator,
      #445651
    - [tg] Work around Cygwin bugs (quirks) hindering the testsuite
    - [tg] In FSH mode, “echo [-n] 'foo\x40bar'” shall not be expanded
    - [tg] Let set -- $(false); echo $? return 0 (POSIXly correct) in
      FSH mode, 1 (needed for getopt(1) support) otherwise
    - [tg] Changes of variables inside Bourne style POSIX functions
      indeed affect the current execution environment (of the function
      caller)
    - [tg] Fix getopts behaviour (sync with AT&T ksh93 not ksh88)
    - [tg] “eval $(false)” shall return 0 (Debian Closes: #550717)
    - [tg] Ensure that /* apo'strophes in comments */ work
    - [tg] Overhaul and simplify handling of (special) variables
    - [tg] Further reduce memory (code/data) and import footprint
    - [tg] Use functions without PATH_MAX limit on GNU/Hurd
    - [tg] Fix tab completing pathnames containing ‘:’, ‘=’, ‘$’ or ‘`’
    - [tg] Support ‘-T <tty>’ even if MKSH_SMALL and fix it
    - [tg] Remove "which" alias "whence -p" to allow "which -a" in
      dot.mkshrc and add more examples, some commented out
    - [tg] Fix print_columns() issue with displaying items where
      characters had differing number of octets and columns, and the
      off-by-one which had hidden this problem with 2-octet 1-column
      and 3-octet 2-column chars
    - [tg] Beautify the manpage in both AT&T nroff and GNU groff
    - [tg] Fix null-expansion of “${x%?}” if $x is unset
    - [tg] Make some globbing (${x%?}) operate on characters instead of
      octets; update manual page to reflect that others still do and
      remove wording that let people think we’d ever support POSuX
      character classes
    - [tg] New ${%foo} returning width of $foo in screen columns, or -1
      if $foo contains an ASCII/latin1/Unicode C0/C1 control character
    - [tg] Fix subtle possible portability problem wrt. CHILD_MAX
    - [tg] Honour ±U on command line of an interactive shell
    - [tg] Fix dead stores and other bugs pointed out by the Clang
      static analyser; put assertions in places it has false positives
    - [tg] Plug uninitialised memory access and possible out-of-bounds
      read of a buffer caught by Valgrind; change one memcpy(3) to
      memmove(3) where srcbuf and dstbuf overlap; place (-DDEBUG)
      workaround for false positive
    - [tg] Rework __attribute__ compiler capability check
    - [tg] Apply errno save/restore related fix from (sync with) oksh
    - [tg] Build.sh: output message when switching from
      autoconfiguration to building / output generation (requested by
      Matt “lewellyn” Lewandowsky); use “conftest.c” ipv “scn.c” (to
      please ccache); ...
    - [tg] Allow “unset foo[*]” (keep attributes) and “typeset foo[*]”
      (for forward-compatibility; R39b it’s the same as “typeset foo”)
    - [tg] When persistent history is enabled (but not MKSH_SMALL) and
      used, intertwine the shells concurrently accessing $HISTFILE
      better ⇒ sync on empty or duplicate line as well (requested by
      Maximilian “mxey” Gaß)
    - [tg] Split off “set ±o posix” and “set ±o sh” again, to be
      somewhat more compatible to various old or vendor versions of
      pdksh and mksh:
      + MKSH_BINSHREDUCED sets FSH but not FPOSIX
      + MKSH_MIDNIGHTBSD01ASH_COMPAT depends on FSH but not FPOSIX
      + The echo built-in behaves the same for FPOSIX and FSH
      + File descriptors > 2 are not closed for both FPOSIX and FSH
      + Both “set -o posix” and “set -o sh” call “set +o braceexpand”
      + In contrast to R39 and below, the errorlevel of
        “set -- $(getopt ab:c "$@")” is now the same in ksh and
        FPOSIX mode (0) and only FSH will use the errorlevel of getopt
        (used to be the other way round)
    - [tg] Document some more shortcomings in the mksh(1) manual page
    - Contributed printf.c fixes:
      + [tg] Make printf(1) builtin use “$'…'” mode, like ksh93
      + [tg] Fix const-cleanliness
  * Remove patches now integrated in upstream or no longer needed
  * Bump Standards-Version, no relevant change
  * Apply patches inside the top-level directory
  * debian/source/format: Enforce "1.0" manually, for now
  * debian/README.source: New, by zack's suggestion, to document some
    particulars of the source package and why I'm not using 3.0 yet
  * debian/README.Debian, debian/mksh.docs: New, document dash bug
  * debian/control: I'm sure we don't need to B-D on locales-all [m68k]
  * debian/control: tweak package short description to well-known text
    and sync long description with upstream's
  * debian/copyright: Update, sync with upstream
  * Rename build/ into builddir/ to avoid phony target vs pathname
    conflict in Makefile (debian/rules)
  * debian/rules: Ensure we use the C locale during build (especially
    for patch application collation order)
  * debian/mksh.examples, debian/rules: Split out dh_installexamples args
  * debian/rules: Update for R39c, printf.c.1.14 particulars
  * debian/rules: When building, try with -combine first but retry if it
    fails, like my OpenSuSE Buildservice packages do (cf. LP: #375604)
  * debian/control: Remove DMUA, I'm a DD now
  * debian/diffs/backport-fixes.diff: New, fixes not yet in R39c

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 28 Feb 2010 14:09:39 +0000

mksh (39.1-4) unstable; urgency=low

  * Update danish translation, Tak tazz
  * debian/diffs/backport-echo-noescapes.diff: new, backport fix
    for "echo [-n] 'foo\x40bar'" expanding even in sh mode
  * debian/diffs/*: refresh and bump version number
  * debian/control: Update and correct package description

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 10 Oct 2009 22:00:37 +0000

mksh (39.1-3) unstable; urgency=low

  * Add support for using pax instead of cpio for extraction
  * Backport fix for return code bug (Closes: #548744)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 29 Sep 2009 12:46:07 +0000

mksh (39.1-2) unstable; urgency=low

  * debian/rules: build mksh-small without floating point support
    also, because it’s ⓐ huge and ⓑ buggy in dietlibc
  * debian/diffs/backport-function-parens.diff: new, support the
    "function stop () {" bashism sometimes popular in sh scripts
  * debian/diffs/zz-version.diff: fix an oversight and use the
    actual 39.1-* version number instead of 38.9.yyyymmdd-* from
    when this patch was first being created in an experimental
    version; refresh diff against original files; use -U1 instead
    of -up for sh.h diff to not get fuzz at the RCS ID

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 26 Sep 2009 21:18:54 +0000

mksh (39.1-1) unstable; urgency=low

  * New upstream version R39 (despite #540512, I got fed up waiting for
    Guillem/Gerrit to contact me), Closes: #541617; complete ChangeLog:
    - [tg] Shut up a bogus gcc warning during configuration process
    - [tg] Spell AT&T consistently in the source code
    - [tg] Tweak mksh(1) manual page, from wbx@ and «lewellyn:#ksh»
    - [tg] dot.mkshrc: fix $@ vs. $* mix-up
    - [tg] dot.mkshrc: add DJB cdb hash function
    - [tg] Sync with oksh: fix Vi editing mode word erase handling, again
    - [tg] Skip whitespace between POSIX style shell function name and
      its definition parenthesēs during detection if an alias of the same
      name already exists to be more robust (Debian Closes: #535970)
    - [tg] Build system improvements for ACK and nwcc, both on Debian sid
    - [tg] Fix spelling error in changelog discovered by Lintian
    - [tg] Aligh “set -o nounset” / “set -u” behaviour with future POSIX
      standard, as discussed with GNU bash maintainers, David Korn from
      AT&T ksh93, and The Open Group; prompted by use in Debian;
      Closes: #539538
    - [tg] add an unsupported way to make printf(1) a builtin
    - [tg] Build system and regression test code and comment improvements:
      better and more comments matching reality better; more reliability
      w.r.t. passed CPPFLAGS; more of the MKSH_SMALL changes may be
      overridden, all of them are now enumerated on the webpage; fixed
      some breakage; portability
    - [tg] MKSH_NOPWNAM and MKSH_SMALL will now both disable the ~fac/
      (homedir) expansion code wholly if defined, not just getpwnam(3)
      calls
    - [tg] shells without job control no longer define the standard
      “stop” and “suspend” aliases (they are pointless anyway);
      regression tests know
    - [tg] use system RCS ID macros on MirBSD if decent enough
    - [tg] shut up bogus gcc 4.5/trunk warnings caused by
      over-optimisation
    - [tg] restore ANSI C compilability broken in R38 (speed up, even)
    - [tg] use memcpy(3) ipv strlcpy(3) if possible and safe and secure
  * Integrate czech translation update, Dêkuji; Closes: #534788
  * Switch to debhelper 5, by suggestion of Patrick “aptituz” Schönfeld
  * Add (commented out) framework for building with klibc, pending
    bugfixes and enhancements I submitted to the Debian BTS; can be
    customised for with/without MKSH_SMALL and dynamic/static linkage
  * debian/copyright: remove setmode.c remark, it is never used:
    mksh-full has it provided by libbsd; mksh-diet, mksh-small, and
    mksh-klibc have the mknod builtin disabled and do not need it;
    strlcpy.c is provided by libbsd, dietlibc and klibc, so neither
    mksh-full nor mksh-diet (nor mksh-klibc) need it, only mksh-small
    in the glibc version (on platforms where dietlibc is unavailable)
  * debian/rules: Append -e to sub-make command line, to force it to
    use the correct build environment (mostly CFLAGS)
  * Apply policy compliance (-o posix if run as sh) to mksh-small
  * Disable duplication of -Wall on the compiler command line
  * debian/rules: improve comments
  * mksh-klibc: debian/rules can now build an MKSH_SMALL flavour
  * Let mksh have all builtins dash has; Closes: #532343
    ‣ New diffs/add-builtin-chdir.diff: add “chdir” builtin (= “cd”)
    ‣ New diffs/add-builtin-printf.diff: add “printf” builtin (manpage)
    ‣ debian/copyright, debian/rules: new source file printf.c (code),
      install and use it; make sure klibc has strtod(3) disabled
    ‣ New diffs/add-builtin_common.diff: common part of the diff
  * New diffs/zz-version.diff: use Debian specific ksh version number
  * debian/rules: reorder some assignments to make it better readable
    and add and improve comments
  * debian/watch: add RCS ID and comments
  * debian/mksh.menu: don’t create an entry for Diet mksh any more
  * debian/mksh.menu, debian/mksh*.xpm: add icons, long description
  * Update spanish translation; from asarch via IRC, ¡gracias!
  * Fix a spelling error and repetitiveness in the German translation
  * Use portuguese debconf translation for the missing parts of the
    brasilian-portuguese translations and mark them fuzzy
  * Translate the missing dutch parts myself (as good as I can)
  * Convert all debconf translation files to UTF-8
  * Remove VCS-CVS field override; the Lintian maintainers have
    agreed to adjust it so that anoncvs-over-ssh is not criticised
  * Switch to Debian Policy 3.8.3, no relevant changes

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 16 Sep 2009 11:08:08 +0000

mksh (38.3-1) unstable; urgency=low

  * New upstream version R38c; complete ChangeLog:
    - [tg] Fix regression tests on OSes insisting on a shebang (Cygwin)
    - [Sean Boudreau] QNX 6.4.2 ed(1) is said to have the bugs fixed
    - [tg] Build.sh bugfixes: -DMKSH_BINSHREDUCED can also be given
      without -DMKSH_SMALL; allow HAVE_REALPATH=x and HAVE_REVOKE=x in
      the environment to re-enable these even if -DMKSH_SMALL disables
      them by default, like mknod already did
    - [tg] -DMKSH_ASSUME_UTF8=0 skips the environment checks, like
      -DMKSH_ASSUME_UTF8=1, but disables the utf8-mode
    - [tg] Apply some more KNF – style(9) – to the source; clean it up
      and further optimise for small size
    - [OpenBSD] Fix segfaults caused by missing check for end of input
      in the tokeniser on “let --” and other input
    - [OpenBSD] Make Vi editing mode ^W behave like Emacs mode’s
    - [tg] If no killpg(3) is available, use kill(2) and hope it works
    - [tg] -DMKSH_NO_LIMITS skips trying to build the ulimit code
  * debian/rules: use DEB_BUILD_ARCH, not DEB_HOST_ARCH, to determine
    if dietlibc should be excluded on certain architectures where it
    is known to fail

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jun 2009 19:45:10 +0000

mksh (38.2-1) unstable; urgency=low

  * debian/rules: fix typo in buildd admin instructions for openpty()
  * New upstream version R38b; complete ChangeLog:
    - [André Wösten] Add __NO_EXT_QNX to avoid picking up the wrong
      waitfor() from <libutil.h> in (while porting to) QNX 6.4
    - [tg] Plug memory corruption issue introduced in R38
    - [tg] Amend dot.mkshrc with a base64 en-/decoder in shell
    - [tg] Import a manpage fix via OpenBSD from Alan R. S. Bueno

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 31 May 2009 17:45:42 +0000

mksh (38.1-1) unstable; urgency=low

  * debian/control: depend on locales-all on m68k because its
    locales and glibc packages are not up to date / installable
  * debian/rules: ignore localedef failure (uncritical to build)
  * New upstream version R38; complete ChangeLog:
    - [tg] Improve regression test output debugging
    - [tg] Fix <libutil.h> prerequisites on MidnightBSD in mirtoconf
    - [tg] Mention that RedHat BZ#496791 cannot currently be fixed in
      the manpage by discouraging use of apostrophes in comments in
      comsubs; add appropriate (expected-fail) regression tests
    - [tg] Sync with OpenBSD ksh (mostly a no-op)
    - [James Butler] Add search-history-up and search-history-down
      keybindings (tcsh-like) to the Emacs command line editing mode
    - [tg] Bind new search-history-{up,down} to ANSI PgUp and PgDn keys
    - [tg] Document ANSI default keybindings (↑↓←→ Home End Del
      PgUp PgDn) in the mksh(1) manual page as well
    - [tg] Optimise internal UTF-8 handling code for size and reusability
    - [tg] Incompatible change: ${foo:1:2} and ${#foo} now operate on
      characters, not on bytes. Characters are octets (set +U) or
      (utf8-mode) MirOS OPTU-8 multibyte characters (set -U)
    - [tg] Improve regression tests relating to ${foo:1:2} and ${#foo} and
      let wc=1#x and utf8-mode
    - [tg] Use per-file copyright notices, move global text to manpage
    - [tg] Expose new MKSH_MIDNIGHTBSD01ASH_COMPAT ifdef; change it to only
      trigger if FPOSIX (or MKSH_BINSHREDUCED and /bin/sh)
    - [tg] Remove already-dead “#if 0” style debugging code
    - [tg] Change some code into a more portable fashion, optimise
    - [tg] Allow [[ $foo ]] (ksh93 extension) mentioned by pgas
    - [tg] Clean up mksh and the contributed arc4random.c for some
      conversion, enum and other warnings for gcc-snapshot trunk r147610
    - [tg] Ensure no function uses more than 768 bytes of stack either
    - [tg, wbx] Add extension to make “!string” lines work like in GNU bash
  * debian/rules, debian/copyright: adjust to upstream changes,
    provide separate copyright file for Debian
  * Remove package-uses-deprecated-debhelper-compat-version
    lintian override to show up in statistics, we want to
    retain the old debhelper version to facilitate backports

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 27 May 2009 21:27:50 +0000

mksh (37.3-2) unstable; urgency=low

  * Provide a way to not use dietlibc for /bin/mksh-static
    on certain architectures; use it for s390 (Closes: #523088)
  * debian/control: run ispell over it

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 08 Apr 2009 18:07:55 +0000

mksh (37.3-1) unstable; urgency=low

  * New upstream version R37c; complete ChangeLog:
    - [tg] Improve præprocessor detection/work in Build.sh
    - [tg] Decouple MKSH_CONSERVATIVE_FDS from MKSH_SMALL
    - [tg] Enable MKSH_CONSERVATIVE_FDS by default on Minix 3
    - [tg] Work around the (in-)famous ACK "const" bug
    - [tg] Optimise structure alignment and padding; Closes: #522778
    - [tg] Retain LOCPATH (for glibc locale) in check.pl
    - [tg] Document, simplify and clean up the code better
    - [tg] Use mirbsd.org eMail addresses consistently
  * debian/rules: try to at least execute the built binaries in !nocheck
    cases, to prevent totally unusable packages from being published;
    Closes: #522779
  * Use LOCPATH and a temporarily generated UTF-8 locale for the regres-
    sion test suite (from Steve “vorlon” Langasek); depend on localedef
    Closes: #522777
  * debian/control: add comment where the dietlibc list comes from
  * Sync package description, etc. with R37c release and upstream
  * debian/control: mention VCS-CVS syntax and place of upstream source

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 07 Apr 2009 23:24:48 +0200

mksh (37.2-1) unstable; urgency=low

  * New upstream version R37b; complete ChangeLog:
    - [tg] Clean up build system and dot.mkshrc some more
    - [tg] Add getrusage(2) implementation using times(3) if none found
    - [tg] Add jobless mode (for Minix 3, Plan 9, …)
    - [tg] Detect the Amsterdam Compiler Kit in the build system
    - [tg] If no RLIM_INFINITY don’t try to do ulimit
    - [tg] Work around gcc4 strict warnings vs. broken system headers
    - [tg] Work around systems with mmap(2) but no munmap(2)
    - [tg] Fix (disallow) bind key macro recursion (instead of beeping
      and going into an endless loop), allow multi-line bind key macros
      (mostly from Alexander Hall), remove dead code (the beeping) and
      optimise
    - [tg] Add (commented out, undesired, standards compliance breaking)
      compatibility code to MidnightBSD 0.1 /bin/sh for ctriv
    - [tg] Clarify the mksh(1) manual page even more
    - [tg] Port to Minix 3 + GCC
  * New upstream version R37; complete ChangeLog:
    - [tg] Rename -o utf8-hack to -o utf8-mode
    - [tg] Fix spacing mode error (pasto) in the mdoc(7) format manpage
    - [tg] Implement $((#…)) unsigned arithmetic calculation, needed for
      arc4random_uniform(3)-in-korn-shell implementation
    - [tg] Really preserve LD_LIBRARY_PATH in check.pl
    - [tg] New Build.sh option ‘-combine’ for building mksh(1) at once
      with “-fwhole-program --combine” (gcc4, llvm-gcc4) if available
    - [tg] Always set COLUMNS and LINES trying as hard as we can, using
      TIOCGWINSZ even if used without FTALKING, and with the sane 80x24
      default if the ioctl(2) fails
    - [tg] Handle _POSIX_VDISABLE being undefined (e.g. Linux/klibc)
    - [tg] <sys/file.h> is only required for flock(2)
    - [tg] Fix multi-column output routine for the corner case if the
      screen is less wide than one output column; 10x Gábor Gergely
    - [tg] Fix ${foo/@(%)/\\x} in UTF-8 mode (utf_widthadj for control
      characters U+0080‥U+009F is slightly broken; this fix shifts the
      brokenness into the command line editing mode only)
    - [tg] Introduce mksh_ari_t and mksh_uari_t internal types to limit
      arithmetics to 32 bit on all systems; currently depending on the
      already-used standard int32_t and uint32_t types. Future expansion
      to 64 bit possible. Document that shell integer variables use this
      type.
    - [tg] The variables PGRP, PPID, RANDOM and USER_ID are now unsigned
    - [tg] Fix two off-by-ones breaking PS1 ending with a newline; bug
      reported by Matthias Diener
    - [tg] Just pass through C1 control characters for now
    - [tg] Code and internal interfaces cleanup
    - [tg] Regression test fixes for Cygwin env(1) being unsorted
    - [tg] Replace the memory allocator by something equally simple and
      homegrown but optimised for use with mksh and free checking
    - [tg] Import a couple of minor fixes (e.g. spelling) from oksh
    - [tg] Fix problems with "set -e" for real; from oksh,
      Closes: #518359
    - [tg] In "set -o posix" mode, have limited echo(1) to improve
      standards compliance; the exact feature set is open for discussion,
      e.g. with pkgsrc® people; for now, only -n as first arg
    - [tg] Make test builtin operator precedence consistent; from oksh
    - [tg] Revamp and fold and enhance the regression tests
    - [tg] Document somewhat surprising behaviour in mksh(1) better;
      here: [ x -eq y ]; for gps23 from #ksh
    - [tg] Reduce memory consumption by allocator simplification
    - [tg] Fix bugs spotted by DEC ucode cc (ULTRIX) and gcc 1.42 (BSD/OS)
    - [laffer1] Make mksh the default /bin/sh in MidnightBSD
  * debian/rules: add support for applying patches to the source code
  * debian/rules: build with new ‘-combine’ option for better optimisation
  * Fix debconf checks if dash is uninstalled; Closes: #518355
  * Use 「--package mksh」 consistently with dpkg-divert
  * debian/control: update package description
  * Upgrade Standards-Version to 3.8.1
    - debian/rules: support nocheck in DEB_BUILD_OPTIONS
    - debian/control: add RCS Id as comment field
  * debian/source.lintian-overrides: add (things not deemed fixable)
    - package-uses-deprecated-debhelper-compat-version (who cares)
    - vcs-field-uses-not-recommended-uri-format (source is available
      via AnonCVS, but pserver must die!)
  * debian/control: prepend :ext: anoncvs protocol to VCS-CVS field

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 05 Apr 2009 15:48:16 +0000

mksh (36.2-1) unstable; urgency=low

  * Reword package description, avoid things not of interest to
    a Debian user; Closes: #505882
  * Switch from patching copyright to merely prepending information
  * Remove all patches, as they have been integrated upstream; add
    ‘-DMKSH_BINSHREDUCED’ to CPPFLAGS to enable the functionality
  * New upstream version; complete ChangeLog:
    - [tg] Add check for naming the output file “scn” instead of “a.out”
      or “a.exe” when compiling scn.c, for Haiku, from Adam “replaced” Hoka
    - [tg] Rewrite utf_backch macro and x_bs2 function into a combined
      x_bs3 function for the Emacs editing mode, to optimise them and get
      rid of the use of __typeof__ (suggested by Anders “ragge” Magnusson
      after the problem was spot by replaced) and one of the uses of the
      statements-as-expressions feature
    - [ahoka] Add mirtoconf check for nice(3), missing on Haiku
    - [tg] Remove all uses of the statements-as-expressions feature by
      rewriting the source code accordingly and optimising some parts
    - [tg] Recognise nwcc (Nils Weller’s C compiler) in Build.sh
    - [tg] If <strings.h> exists, pull it in for strcasecmp(3)
    - [tg] Welcome QNX/Neutrino; work around broken /bin/ed
    - [tg] Simplify, shorten, speed up PS1 in dot.mkshrc
    - [tg] Remove some dead code courtesy of scan-build native runs
    - [tg] Add some casts to prevent LLVM+Clang warnings
    - [tg] Work around llvm-gcc-4.2.1 -Wformat pickyness
    - [tg] Add new Build.sh option ‘-llvm’ (clang, llvm-gcc)
    - [tg] Speed up mirtoconf if ‘-DMKSH_ASSUME_UTF8’ is set
    - [tg] Add the workaround for Debian #492377 into the main mirtoconf
      function (hiding gcc errors during the configure phase) because
      Gentoo has similar scanner issues; reported by Hanno Böck
    - [tg] If an MKSH_SMALL has arc4random(3), skip the rand(3)/srand(3)
      fall-back altogether to shrink size, also removed need for time(3)
    - [tg] Fix alias expansion recursion check if the word to be expanded
      is immediately followed by end of input, add test case; spotted by
      Michael Hlavinka in pdksh and mksh; RedHat #474115
    - [tg] Fix string/wdstring confusion preventing bashiop (&>foo) to
      work inside a function, add regression test, limit to 99 fds
    - [tg] change regression tests to ‘set -U’ or ‘set +U̲ instead of
      ‘set -o utf8-hack’, as well as query using ‘$-’ ipv ‘$(set +o)’
      (easier and more reliable)
    - [tg] Add comment to regression tests which can fail on slow machines
      or Cygwin environments due to timing issues
    - [tg] Remove a lot of superfluous casts, improve type cleanliness
    - [tg] Insert a couple of /* CONSTCOND */ for lint
  * New source package and build structure:
    - distfile is now packaged *inside* the orig tarball instead of repak-
      kaged, similar to PostgreSQL
    - debian/rules “patch” target takes care of it, as per Policy Manual
    - debian-specific things (debian/ directory and all patches) are kept
      in a publically accessible CVS repository
    - VCS-CVS and VCS-Browser fields have been added to debian/control
    - source is extracted to ./mksh and built, using relative paths to the
      source code, in ./build/full and ./build/small; both are .cvsignore’d
    - most files now carry an RCS ID
    - paths in mksh.install, mksh.manpages, rules have been adjusted
  * word-wrap debian/control lines to 80c
  * add build dependency on cpio (for distfile extraction)
  * for non-pbuilder testsuite runs (needed on gnubber), rename the ./manual
    file tested for to ./attended to clarify its purpose
  * debian/rules: share code instead of duplicating it
  * debian/rules: fix testsuite use of $? and $x (gmake wants $$? and $$x)
  * debian/rules: use sensible stamp files and new paths, coming along with
    the new “patch” target
  * remove the ‘-Q’ option from Build.sh invocation, which is gone

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 14 Dec 2008 20:38:42 +0000

mksh (35.2-3) unstable; urgency=low

  * Apply upstream changeset 10048D15ABE2EA76C75:
    - Bring back automatic -o posix setting if the shell is invoked
      as “sh” or “-sh” (unless compiled with MKSH_SMALL), add
      regression test
    - If -o posix is set, do not keep file descriptors created via
      I/O redirection, as Korn Shells do, private; add regression
      test; Debian Closes: #499139; reported by Markus Schaber and
      Agustin Martin Domingo
  * Change mksh-internal version number to document aberration from
    pristine source
  * Add DM-Upload-Allowed control field to prepare for future updates
  * Add workaround to “posix-mode-2” regression test to cope for GNU
    getopt idiocy to not stop argument parsing upon encountering the
    first non-flag argument: “ln -s mksh -sh” tries to parse -s and -h

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 19 Sep 2008 10:12:59 +0000

mksh (35.2-2) unstable; urgency=low

  * Workaround for false positives on IA64, Closes: #492377
    (by circumventing the regex matcher for code not actually used)
  * The mksh-static binary on non-dietlibc arches was not statically linked
  * MKSH_STATIC implies MKSH_NO_PWNAM, remove duplicate definition
  * Add build dependency on en_US.UTF-8 locale data for the regression tests
  * Fix lintian -vIi warning debian-copyright-line-too-long by wrapping

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 28 Jul 2008 20:54:17 +0000

mksh (35.2-1) unstable; urgency=low

  * Update to BSD-advertising-clause-free new upstream release; changelog:
    - Simplify and refactor the ulimit builtin, partially from oksh
    - Some style cleanup; use appropriate integer types
    - Fix a bug in table (e.g. kill -l, tab completion) display: the width
      of non-ASCII characters is now honoured in the utf8-hack mode
    - Improve handling of invalid UTF-8 in certain areas, and multibyte
      (UTF-8 / CESU-8) in general
    - When using “typeset -Z«n»” on an integer variable with a base other
      than ten, zero-pad the value instead of the base – pdksh, oksh, zsh,
      and AT&T ksh93 are wrong here; GNU bash doesn’t even have typeset
    - Improve parsing of “set +o” output where done (dot.mkshrc, check.t)
    - Improve regression tests
    - Support for base-1 numbers: in non-utf8-hack mode, ‘1#x’ means the
      same as the ASCII code for ‘x’ (e.g. 78hex), where ‘x’ is any single
      octet (byte); in utf8-hack mode, ‘x’ is either a valid and minimali-
      stically encoded UTF-8 multibyte character in the range 0000‥FFFD,
      or a single octet with no trailing octets (bytes), which will then be
      converted as if it were an ASCII value, or, if bit7 is set, be mapped
      into the PUA range of EF80‥EFFF assigned by CSUR for this purpose;
      this mapping is, in both cases, bidirectional; the planned base-0
      number support is not possible with the code, so use base-1 (with
      utf8-hack disabled, or & 0xFF) instead (while it is recommended to
      parse only single octets, there is a regression test showing correct
      and safe multibyte parsing, which however is error-prone to implement
      and thusly not recommended) – “genial” replaced@TNG, “this sounds
      fun” ggergely, agreed bsiegert@ and others
    - Pull in more current versions of supplied files; use Unicode 5.0
    - Clean up unused definitions in build system; document MKSH_CLS_STRING
    - Remove advertising clause from copyright file; while we’d be pleased
      to be mentioned if something contains our code, tg@ will no longer
      enforce the requirement to advertise with that specific formula, and
      we’d prefer if people remember the OpenHAL vs ath5k incident and that
      they cannot simply change licencing of existing code; patches sent to
      the MirOS Project for inclusion shall be accepted if they’re agreed
      to match this licence
    - Simplify dot.mkshrc sample file: licence is merged into the main
      copyright file; AT&T ksh93 compatibility was improved
    - Fix a display problem regarding fullwidth characters (e.g. CJK)
    - Set the “C” locale in Build.sh for tool execution; otherwise, cer-
      tain OEs behave strange; thanks to Adam “replaced” Hoka for spotting
    - Use en_US.utf8 as UTF-8 locale for the testsuite for now
    - If setlocale(LC_CTYPE, "") is not available, look at the environment
      variables ourselves – brings UTF-8 support to poor OSes
    - Remove some now-dead code; speed up configuration process; shrink
    - Default to no setlocale(3) due to stubbed or missing locale support
      on GNU/Cygwin, OpenBSD, OSF/1 in Build.sh; a few more that are quite
      unlikely to have a UTF-8 locale: BSD/OS, Interix, Minix, PW32,
      Ultrix, AT&T UWIN; default to always UTF-8 on Plan 9
    - Fix for testsuite unexpected failure if running as root in one case
    - Initialise all shell integer variables (OPTIND, PPID, RANDOM,
      SECONDS, TMOUT) to base 10
    - Reintroduce from mksh pre-R24 shell integer variable PGRP set to
      the PID of the process group leader via getpgrp(2)
    - New shell integer variable USER_ID set to the geteuid(2) and used
      by dot.mkshrc to speed up logins, saves a spawn of id(1), mentioned
      by and realisation planned with Andreas "gecko2" Gockel
    - Fix dot.mkshrc tilde replacement in both $PS1 and the pushd/popd/dirs
      implementation when the home directory is empty, the root directory,
      or ends with a slash (disable replacement in that case)
    - Support dietlibc, force it into providing a BSDish caddr_t
    - Do not use LDFLAGS and LIBS while compiling with -c
    - Add realpath(3) builtin, to further speed up logins and chdirs
    - Optimise the code somewhat by making use of possible assumptions
    - Set the “C” locale in test.sh as well to quell warnings
    - Split the regression tests that use locale between en_US.utf8 and
      en_US.UTF-8, since not all OSes support either one, and make only
      HP-UX and GNU use the latter
    - Fix kill, mknod(8) builtin usage msg, from Igor Sobrado via oksh
    - Use proper ptrdiff_t casts for pointer arithmetics, inspired by an
      oksh commit from Federico Schwindt
    - Remove check category “pdksh” from check.t and test script
    - Improve Darwin, OSF/1, HP aCC, SUNpro version reporting
    - Support GNU bash “&>” extension, even better than they do, suggested
      by Lukas “smultron” from MidnightBSD
    - Basic support for LLVM+clang in the build system with experimental
      “ccc” compiler driver; llvm-gcc worked as-is before already
    - Better support for contributed arc4random.c file
    - Do not spin if unlink(2) fails on $HISTFILE, from Decklin Foster
    - Dump the perl(1) $^O variable in test.sh to logs
    - Pull in latest changes from oksh
    - Allow white space between a here string indicator and the string,
      accidentally discovered by twkm (#ksh, freenode)
    - Allow fd specifications outside the 0‥9 range for I/O redirections,
      and bounds check them to be lower than the FDBASE definition,
      currently still 10 if MKSH_SMALL, 24 otherwise (unportable)
    - Improve the regression test suite: for one test, we had a bizarre
      constraint telling it won’t work on UWIN, which was based upon false
      assumptions, but Tru64 would fail it since its cat(1) unexpectedly
      outputs some error messages (fix by closing stderr for cat); another
      test would unexpectedly print no error message on Solaris (fix by
      making the error message optional in the perlre(1) used)
    - Switch back to en_US.UTF-8 for glibc, Debian can do both, Mandriva
      fails on en_US.utf8 (XXX no libc5 auto-detection to disable it)
    - IRIX also has no UTF-8 locale at all, confirmed by Elias Pipping
    - Fix regression test suite for MKSH_SMALL
    - Bring in latest changes from oksh (OpenBSD ksh, not DeliLinux crap)
    - Fix abuse and unsafe use of str_save() and str_nsave()
    - Optimise the implementations of str_save() and str_nsave()
    - If MKSH_AFREE_DEBUG is defined, guard against afree()ing a pointer
      which has not been allocated from the given pool, from Todd C. Miller
    - Fix attempt to free a pointer to stack (function-local) storage when
      redefining a function containing a call to the “time” built-in,
      discovered by Elias Pipping, patch by Jared Yanovich, help from
      Todd C. Miller
    - Protect a little against people not running “./test.sh -v” but
      calling it with, for instance, GNU bash (as homsn did…)
    - Honour $PERL environment variable in test.sh, improve scanning for
      Perl, do not use potentially undefined $^O, print Perl version
    - Add <sys/types.h> as <ulimit.h> requirement (dietlibc)
    - Work around bug in BSD/OS 3.1 /bin/ksh (PD KSH v5.2.8 96/08/19)
    - Add regression tests from OpenBSD’s <bsd.regress.mk> suite
    - Use better CPPFLAGS for AIX, Minix 3 (from pdksh)
    - Expose the “s ≠ NULL” str_[n]save_() API and use it where the string
      can never be NULL (local stack storage), from gcc-4.2 warnings
    - Clean up pointer-to-integer-cast warnings in the mirtoconf process
  * New debian-policy version: 3.8.0.1
    - DEB_BUILD_OPTIONS: add -Wall to default CFLAGS, fix “noopt” handling,
      add “nostrip” handling, ignore “parallel=«n»” as we cannot specify a
      maximum value to Build.sh
    - Convenience copies: switch from a contributed arc4random.c file to
      using the new libbsd Debian package, 10x Hector, Guillem et Aurelien!
  * debian/control: sync Description field with upstream suggestion
  * Rename menu entry from "MirBSD ksh" to "MirBSD Korn Shell" for clarity
  * Add a mksh-static binary, for initrd, initramfs, installer, rescue
  * Integrate translation updates, ありがとう; Closes: #483506
  * Integrate translation updates, tack; Closes: #491950

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 22 Jul 2008 20:42:23 +0000

mksh (33.4-1) unstable; urgency=low

  * New upstream release; changelog:
    - Move a portability define from sh.h to the setmode.c helper, as it’s
      only needed there, and we want to use the latter from MirMake as well
    - SECURITY:  when spawning mksh on a new terminal, for example with
      “sudo mksh -lT/dev/ttyC7”, flush all of that tty’s I/O first
    - dot.mkshrc: ensure “ls” is no alias, don’t hardcode its path
  * As dash won’t be the default /bin/sh without the current alternative
    handling / debconf mechanism in lenny (as per the mail from Martin
    Zobel-Helas), there is no need to act regarding our debconf scripts
    and /bin/sh ability, so I think this Closes: #469675

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 11 Apr 2008 17:38:02 +0000

mksh (33.3-1) unstable; urgency=low

  * New upstream release; changelog:
    - Handle Ultrix mmap(2) having a different prototype (returning a caddr_t
      instead of a void * and not defining MAP_FAILED; making Ultrix 4.5 a
      fully supported platform
    - Decrease code size and optimise (using puts-style functions instead of
      printf-style functions for fixed strings; bool instead of int)
    - Correct behaviour of “export”, “export -p”, “readonly”, “readonly -p”,
      “typeset”, “typeset -p”, “typeset” and their respective descriptions in
      the manual page; problem reported by Danijel Tasov
    - Work around dup2(2) problem (preserving the close-on-exec flag) on
      Ultrix using code from mirbsdksh-1.11, lost in oksh
    - Clean up Build.sh a little more
    - Correct quotes and some other stuff in the regression tests; fix for
      running with old Perl (5.002 or so, Linux 2.0, BSD/OS)
    - Export the new “__progname” and “__perlname” environment variables to
      the suite run from check.t in check.pl
    - Do not mistake IBM xlC and VisualAge for different things, thanks to
      Pascal “loki” Bleser from OpenSuSE for information on them

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 02 Apr 2008 21:45:54 +0200

mksh (33.2-1) unstable; urgency=low

  * New upstream release; changelog:
    - Fix some minor code issues remarked by MIPSpro
    - Port to SGI IRIX 6.5 (uname: IRIX64) using gcc and MIPSpro
    - Scan for a lot more compilers; add support for MIPSpro
    - Ignore if the OS doesn’t define MAP_FILE for mmap(2)
    - Use sys/types.h as sys/mkdev.h dependency
    - Enable OSF/1 V2.0 /bin/sh to run Build.sh
    - Add strcasecmp(3) proto for Ultrix 4.5 only (imake style)
    - Add S_ISLNK if the OS doesn’t define it
    - Use tempnam(3) if mkstemp(3) not found – not recommended
    - Reduce dependency on certain OE facilities: printf(1), fgrep(1) being
      able to scan for two patterns at the same time, perl5 being named perl
    - New -T- option for dæmonisation, cf. man page
    - Port to BSDi BSD/OS 3.1 (gcc 1.42 and gcc 2.7.2.1 supported)
    - Simplify the dot.mkshrc file and make it more robust
    - Report OE and $CC version in Build.sh, for logs
    - Fix look’n’feel of the mksh(1) manual page, so that it still looks best
      in AT&T nroff(1), looks much better in GNU groff (the PDF version we
      place on the website), and looks some better and gains the ability to
      copy’n’paste from it for GNU gnroff -Tutf8, originally prompted by
      Patrick “aptituz” Schoenfeld and “lintian -viI mksh*.changes”, but then
      improved (and nroff hacked) by tg@ a lot
    - Shut up some gcc warnings (explicit braces; cast MAP_FAILED)
    - Try to get rid of the test “if the compiler fails correctly” by using
      the errorlevel of the $CC process (except with Microsoft Visual C++
      which returns non-zero even on success sometimes), thus supporting
      DEC C on OSF/1 (and, quite possibly, gcc3 on Mac OSX Leopard)
    - If revoke(2) and flock(2) are found, check if they’re declared
    - Promote Tru64 to a fully supported operating environment, even though
      it needs a plethora of _*_SOURCE defines and has SIGMAX instead of NSIG;
      OSF/1 V4.0 and Tru64 (OSF/1 V5.1) are supported with both gcc and
      HP/Compaq/DEC C in various versions
    - Generalise the workaround for incompatible sig_t across the platforms
      that need it (currently, OSF/1 and PW32)
    - Shut up annoying warning about gcc 2.7.2.3, 2.8.1, 2.95.x not knowing
      the “-std=gnu99” and “-std=c99” options without setting proper errorlevel
  * Remove debdiffs for things included in upstream:
    - manpage diff
    - displaying of OS and compiler versions before build
  * Update arc4random.c file from MirBSD contrib repository for now, until we
    have libbsd in Debian !kfreebsd sid (coming soon I hope)
    - fixes “warning: ignoring return value of ‘read’, declared with attribute
      warn_unused_result” occuring on e.g. Fedora GNU/Linux
  * Integrate translation updates, merci; Closes: #471009

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 28 Mar 2008 20:34:00 +0000

mksh (33.1-2) unstable; urgency=low

  * Help backporters by specifying explicitly versioned debconf/cdebconf
    dependencies, thanks Patrick “aptituz” Schoenfeld for mentioning
  * Integrate manpage diffs from mksh-current to fix “lintian -viI”, also
    from aptituz, and a couple of other issues (' vs ’ vs ´, ' vs ‘ vs `,
    - vs ‐ vs − vs – vs —, ^ and ~ in the Postscript version)
  * Add a debian/watch file, idea from aptituz too, hints from uscan(1)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 04 Mar 2008 00:31:08 +0000

mksh (33.1-1) unstable; urgency=low

  * New upstream release; summary of changes:
    - Sync with OpenBSD ksh (no real functional changes)
    - Enhance the print builtin with two new escape sequences: \xAB
      parses the next up to two hexadecimal digits AB and outputs a
      raw octet (byte) whose ordinary value is AB; \uABCD parses up
      to four hexadecimal digits and outputs the UTF-8 (CESU-8) re-
      presentation of the unicode codepoint U+ABCD from the BMP
      (Basic Multilingual Plane), not depending on the locale
    - The . (“dot”) command (and its counterpart source) needs an
      argument (the script to source); from Debian pdksh package
    - In the lexer, do not expand aliases if there is an opening
      parenthesis just after the token (from Debian pdksh). This
      fixes the namespace issue that caused a POSIX function de-
      finition stop() { … } to fail due to “stop” being a built-
      in Korn shell alias. Now, aliases are removed when a POSIX
      function with the same name is defined; Korn functions are
      still different: their definition does not fail, but the
      alias retains its precendence (unchanged behaviour)
    - Accordingly, do not disable built-in aliases in POSIX mode any more
    - Since POSIX mode now only turns off braceexpand mode (which
      can then be turned back on), do not handle being called as -sh
      or sh specially any longer
    - Clean up the source code: make some constants private to the
      only file using it; optimise; comment some code; improve
      portability with regards to stupid tools in /usr/bin (or
      /usr/xpg4/bin) and foreign compilers
    - Implement “here strings” (like ksh93 or zsh; GNU bash col-
      lapses white space if the string is not double-quoted): you
      can now replace “print -r -- "$foo" | command” with
      “command <<<"$foo"” with the very same semantics as
      “command <<EOF
       $foo
       EOF” (stripping initial tabs is not possible)
    - Implement string replacement ${var/pattern/string} (where
      pattern is an extended glob pattern), like GNU bash; like
      with the substring accessor (${var: x: y}) mksh implements
      almost all corner cases (and double slash), but do not
      handle trimming arrays yet
    - Side note: You can now, as a consequence of the two items
      above, write, for instance, x=${x//foo*bar/baz} instead of
      the more complicated x=$(sed -e 's/foo.*bar/baz/g' <<<"$x")
      or the mksh R32 and before idiom x=$(print -r -- "$x" | sed
      -e 's/foo.*bar/baz/g') – be sure to check $KSH_VERSION first
      though
    - Use the new Mdocdate RCS keyword in the manual page mksh(1)
      as well; since this is not portable in tmac.doc especially to
      GNU groff, prepend a seven-liner implementing it to the .Dd macro
    - Fix a mistake in using the .Nm macro in the manual page
    - Make Build.sh and the generated test.sh more chatty about what
      they’re doing and what versions (aids debugging build logs)
    - Update the dot.mkshrc sample and make it more portable; it requi-
      res mksh R33 or above now though due to use of special functions
    - Enhance the website, especially the section about official
      testing: now, the tests are split into tests done by us via
      Makefile (MirOS only), Build.sh (portably), porting frameworks,
      with arc4random.c added, tests by others via Build.sh, via
      packaging frameworks, failed tests; more links
    - Note: the “vi” editing mode is code of historical value and, at
      the moment, unmaintained. It does not benefit from the fixes to
      the “emacs” editing mode (horizontal scrolling) or new features
      (bind keys that end their sequence with a tilde; UTF-8 support).
      Neither is it supported in either editing mode to bind keys that
      generate a sequence consisting of more than just a prefix (ESC,
      ^X, or ESC [), another octet and (“emacs” only) an optional tilde
      (but this might come in the future). This is explicitly mentioned
      here due to a user inquiry.
    ‣ This means that pdksh bugs #190566, #246530, #297234 specifically
      do not apply to mksh and users might want to switch
  * Have the OS and compiler version appear in the build logs (debugging)
  * Bump Standards-Version and double-check that the menu category is OK
  * Integrate translation updates, Хорошо; Closes: #467182

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 02 Mar 2008 16:12:59 +0000

mksh (32.1-1) unstable; urgency=low

  * New upstream release; summary of changes:
    - Checks for symbol declarations are compile time checks, not link
      time checks; fixes (optional) arc4random on AIX
    - Widen the range for array indicēs to the entire unsigned 32-bit
      integer range (enough for ino_t on BSD); wrap numbers outside of
      that range into it for simplicity (e.g. foo[-1] = foo[4294967295])
    - Fix an internal error when using a pipeline as co-process
    - Relax requirement on compilation environment to provide certain types
    - Optimise some more for size (struct padding; functions → macros, …)
  * Integrate galician translation, Closes: #447947

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 25 Oct 2007 18:36:27 +0000

mksh (31.4-1) unstable; urgency=low

  * New upstream release; summary of changes:
    - Support pcc (the ragge version of the Portable C Compiler)
    - Add pushd/popd/dirs functions (csh) and precmd/chpwd hooks (zsh)
      to dot.mkshrc which now requires readlink(1) with -f; requested
      by many (e.g. some Gentoo users; XTaran of symlink.ch)
    - Enable colour escapes in dot.mkshrc since almost nobody groks how
      to do it right from the manual
    - Remove -DMKSH_NEED_MKNOD checks from Build.sh, people should use
      the HAVE_MKNOD environment variable
    - Implement parallel make in Build.sh (not used by Debian)
    - Fix another busy-loop spinning problem introduced by an icc warning,
      thanks to spaetzle@freewrt.org for keeping to bug me to look for it,
      as it affected GNU/Linux most, followed by Solaris, rarely BSD
    - Improve standard integer type detection in Build.sh
    - Cleanups in code, build script and manual page
    - Clean up Build.sh and “test … -o …” doesn’t exist in Bourne
    - Detect if the non-standard u_int32_t type, which was unfortunately
      used by the OpenBSD project in designing the standard arc4random(3)
      API, is present (which it isn’t on Solaris), and, if not, emulate
      it using the standard uint32_t (ISO C99) from <stdint.h>, which we
      fake as needed (if the standard integer types are not present, e.g.
      on PW32 and OSF/1); change mksh as well as the arc4random.c
      contribution to not use these non-standard types
    - Remove unused types from the faked <stdint.h> file
  * Integrate updated translation into portugués, Closes: #444218
  * debian/rules: wait for script(1) to return, in case it runs
    asynchronously; we have seen weird results on Debian and Fedora

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 15 Oct 2007 18:23:01 +0000

mksh (31.2-1) unstable; urgency=low

  * New upstream minor release (R31b); summary of changes:
    - Fix a syntax error in Build.sh checking for TenDRA
    - Fix typo (blsk → bksl) in check.t test naming
    - Autoscan for uint32_t, u_int etc. presence
    - Fix some memory leaks, mostly by NetBSD® via OpenBSD
    - The “unset” builtin always returns zero, even if the variable was
      already unset, as per SUSv3 (reported by Arkadiusz Miskiewicz via
      pld-linux and oksh)
    - In tab-completion, escape the question mark, reminded by cbiere@tnf
    - Fix a busy-loop problem, Debian #296446 via oksh
    - Fix a few display output problems in the build script
    - Shut up some gcc warnings on Fedora; beautify some code
    - Support OSF/1 with gcc2.8, thanks to Jupp Schugt
    - Fix gcc4 detection of __attribute__() on non-SSP targets
  * debian/control: sync description with that of packages for other OSes
  * debian/menu: Apps → Applications, as per Lintian
  * debian/rules: do not run the testsuite with script on Debian GNU/HURD,
    because some translators seem to be unable to cope with the chroot
  * arc4random.c: use uint<n>_t consistently, helps compiling on OSF/1

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 11 Sep 2007 14:00:20 +0000

mksh (31.1-1) unstable; urgency=low

  * New upstream release (R31); summary of changes:
    - Support the TenDRA compiler (possibly also Ten15, not tried)
    - Begin supporting Fabrice Bellard’s Tiny C Compiler (tcc on Debian
      cannot link due to duplicate symbols in GNU libc, thus unfinished)
    - Improve some mirtoconf checks (most notably, mknod(2) and macros)
    - Add new emacs editing command “clear-screen” (ESC ^L) as requested
      by D. Adam Karim <archite@midnightbsd.org>
    - Support building for MidnightBSD
    - Add new shell alias “source”, semantics like the GNU bash builtin
    - Add new shell option “set -o arc4random”, controlling whether
      rand(3) or arc4random(3) is used for the $RANDOM value, use
      arc4random_pushb(3) if it exists
    - Add new builtin “rename” (just calls rename(2) on its arguments),
      for rescue purposes (like renaming ld.so)
    - Fix the inofficial OpenBSD port, from D. Adam “Archite” Karim, 10x
    - Disable the less(1) history file by default (privacy issues) in the
      sample dot.mkshrc file; mention other things in etc_profile (the
      additional sample mentioned on the mksh website)
  * Put the arc4random.c file under version control
  * Clean up the copyright file (rm commented stuff from Debian experimental)
  * Mention /dev/tty is also needed in debian/rules pre-build echo

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 07 Sep 2007 19:34:25 +0000

mksh (30.1-1) unstable; urgency=low

  * New upstream major release (R30); summary of changes:
    - Build on and for Solaris, Linux and MirBSD with Sun's C compiler
    - No longer build a statically linked shell by default; do not try,
      do not provide any means; user has to use LDFLAGS instead.
    - Remove some probably dead mirtoconf checks
    - Remove commented out -fwhole-program --combine check and still
      active -fno-tree-vrp bug workaround thing, the latter because the
      bug seems to only appear for functions that also exist as a builtin
      (which was declared with the nonnull attribute)
    - Fix a long-standing typo, 10x moritz@obsd
    - Prefer more common signal names (SIGCHLD) over uncommon ones (SIGCLD)
    - Quieten gcc and support SUNpro 5.8 on Solaris 10 on sparc64
    - Optimise signal handling and detection; enable compilers whose
      præprocessor doesn't have -dD to generate list of signals
    - Optimise mirtoconf meta-checks for persistent history etc.
    - Fix a bug preventing manual page generation on Solaris
    - Add support for the Intel® C Compiler and quieten it a little;
      fix a few minor buglets (mostly type conversion) its too verbose
      warnings show, as well as some errno ab-/mis-use
    - Remove support for honouring the CPP environment variable;
      $CC -E - is simply used instead in the places where $CPP was used
      previously, because that was used in other places already, and
      to prevent it from behaving differently from the $CC used
    - If a file called arc4random.c is lying around in the source directory
      at mirtoconf time, scan for <sys/sysctl.h> and use the file if
      arc4random(3) isn't found otherwise. From Debian GNU/kFreeBSD.
    - If the basename of argv[0] starts with “sh”, activate FPOSIX early,
      preventing some typical ksh aliases from being defined
    - If FPOSIX, don't pre-define aliases (except integer and local) to
      benefit operating environments that never heard of the great Korn Shell…
    - #if defined(MKSH_SMALL) || defined(MKSH_NOVI) disable the vi editing mode
    - Don't try to execute ELF, a.out, COFF, gzip or MZ binaries
    - Can be built on HP-UX (PA-RISC and IA64) with gcc or HP C/aC++
    - Support x=(a b c) bash-like array initialisation
    - Support ${foo:2:3} bash-like substring expansion
    - Many mirtoconf improvements, fixes; speed-up; better portability
    - Enable compilation using Microsoft C/C++ Standard Compiler
    - Add UWIN build target using various compilers with the cc wrapper
    - Fix struct padding mistakes uncovered by the Microsoft compiler
    - Fix double initialisation / unused value assignment errors
      unveiled by Borland C++ Builder 5.5
    - Fix superfluous code detected by gcc 4.2
    - Fix large file support for OSes that require CPPFLAGS contains
      -D_FILE_OFFSET_BITS=64 – it was detected but not actually used
      in the build; thanks to hondza for the problem report!
    - Give the lexer a bigger state stack if !MKSH_SMALL
    - Prepare for addition of make(1)-style search/replace operations;
      correct the code for other substitution expansion operations
    - Default $CC to cc not gcc, this is no non-unix-ware ☺
    - Support AIX with gcc and xlC; clean up code to warning-free
    - Prefer well-known signal names to alphabetically earlier ones
    - Fix a bug delivering ERR and EXIT pseudo-signals to traps combined
      with “set -e”, thanks Clint Pachl and Otto Moerbeek for the hint
  * Update German translation, Closes: #428590 (still pending resolution
    of the dash-as-/bin/sh and debconf common field issue described in
    http://thread.gmane.org/gmane.linux.debian.devel.release/17423 so
    please do not submit new translations until that issue is resolved)
  * Reflect changes in the description in debian/control

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 26 Jul 2007 20:25:02 +0000

mksh (29.6-2) unstable; urgency=low

  * Re-run debconf-updatepo which was missed after we changed note into error
  * Fix arc4random on HURD by integrating it into the Build.sh script and
    scanning for prerequisite headers

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 10 Jun 2007 07:51:06 +0000

mksh (29.6-1) unstable; urgency=low

  * New upstream formal release; summary of relevant changes:
    - Remove some redundant or unused functions
    - Fix several horizontal scrolling, display, scrollbar, etc. bugs
      unveiled by David Ramsey
    - Fix a few bugs found by Coverity Scan
    - Optimise dot.mkshrc sample file; add a speed alias
    - Fix a few shortcomings in the build system
  * Pull in arc4random support
  * Make it possible to install mksh as /bin/sh the same way as
    dash does, copy the necessary files from dash (my apologies to
    the translators, I simply search'n'replaced the term dash by mksh)
  * Install dot.mkshrc as /etc/skel/.mkshrc conffile

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 28 May 2007 18:12:23 +0000

mksh (29.3-1) unstable; urgency=low

  * New upstream formal release; summary of changes:
    - portability fixes (darwin, hp-ux, solaris, new port to aix)
    - size optimisation if utf-8 mode is assumed by default (not in Debian)
    - small manual page fixes
    - Do not scan for and use "-fwhole-program --combine" because it's the
      cause of at least http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=408850
      and breakage with FORTIFY_SOURCE on SuSE; thanks to Pascal Bleser (yaloki),
      Marcus Rueckert (darix), Martin Zobel-Helas, Steve Langasek (vorlon) for
      tracking this bug down in two different places; Closes: #421518
  * remove the possible workaround mentioned in the changes for 28.9.20070309
    because the problem has been solved upstream

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 30 Apr 2007 21:53:12 +0000

mksh (29.2-1) unstable; urgency=low

  * New upstream formal release; summary of changes:
    + a plethora of UTF-8 fixes:
    - display control characters U+0080..U+009F the same as U+0000..U+001F,
      i.e. a caret followed by the character corresponding to the control
      character XOR 0x0040, treat their width as 2 subsequently
    - fix crash (cpu hog in spinning loop) on meta-tab + backspace
    - strip off UTF-8 byte order mark at beginning of input
    - if a BOM is encountered, switch on utf-8 command line editing mode
    + in utf-8 command line editing mode, handle invalid input more strictly:
    - if in x_literal(), i.e. the ^V mode (bind to quote), allow it as before
    - if it's the start of an invalid multibyte sequence, reject with a beep
      (e.g. if trying to input latin1 chars)
    - if it's an invalid or partial multibyte sequence, reject silently
    -> this makes command line editing much more robust
    + other bug fixes:
    - in a rare condition (error path), the wrong function was used to copy
      a string that could contain embedded NULs (encoded format), leading to
      memory access past malloc'd area
    - in the same path, fix an out-of-bounds access inherited from openbsd ksh
    -> discovered on Debian GNU/Linux experimental ia64, glibc 2.5-beta
    + new functionality:
    - if execve() fails, before passing the file to $EXECSHELL, open it and
      try to parse a shebang line; if we find one, do it ourselves
      (the good part of this is that it even works when there is a UTF-8 BOM
      before the shebang magic sequence)
    - for shebang processing, not only NUL or LF but also CR terminate the line
    - enhancements to the "dot.mkshrc" sample file (which is now regularily
      used upstream as well)
    - if the internal function exchild() fails, don't just tell the user that
      it failed, tell him WHAT failed (unless -DMKSH_SMALL)
    + code cleanup changes:
    - remove unused functions, macros
    - fix typos, errors, etc.
    - shut up gcc 4.1.2 warnings
    - Build.sh cygwin vs unix cleanup/simplification
    - shrink manual page to 39 DIN A4 pages when output as postscript
    + reliability changes:
    - if $CC supports -fstack-protector-all, add it to $CFLAGS
    - if $CC supports -fno-tree-vrp, add it to $CFLAGS if $CC is subject to
      the bug http://gcc.gnu.org/bugzilla/show_bug.cgi?id=30785
    - add mirtoconf check for "large file support", requested by bsiegert@,
      needed for some *nix, idea and implementation hints from GNU autoconf
    - add zsh workaround to Build.sh, just in case (untested)
  * disable the possible workaround mentioned in the changes for 28.9.20070309
    because I was unable to verify/test it; maybe it only applies to the glibc
    in experimental anyway, we'll see to that later
  * add a comment about the regression test needing openpty() to debian/rules
  * remove non-ASCII (i.e. high-bit7) characters from diff/changelog
  * slightly enhance package description
  * properly indent homepage link in description, thanks KiBi (kfreebsd team)

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 25 Apr 2007 11:36:42 +0000

mksh (28.9.20070309) experimental; urgency=low

  * Add possible workaround for #408850 by disabling -std=gnu99 (untested)
    so that this package at least compiles on Alpha until the bug
    can be fixed
  * Restore Debian prefix in copyright file accidentally lost in 28.9.20070304
  * Do not build-depends-on-essential-package-without-using-version, remove
    explicit dependency on bsdutils

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 10 Mar 2007 01:12:20 +0000

mksh (28.9.20070304) experimental; urgency=low

  * Due to failures like this one:
    ``cat: /build/buildd/mksh-28.9.20070218/builddir/screenlog.0:
      No such file or directory''
    in http://experimental.ftbfs.de/fetch.php?&pkg=mksh&ver=28.9.20070218&arch=powerpc&stamp=1171913314&file=log&as=raw
    - remove the use of GNU screen to run the testsuite again
    - use 'script' from the Debian bsdutils package) to run the
      regression test suite within a controlling tty
    (this is experimental)
  * New upstream release candidate; summary of changes:
    - Work around Solaris /usr/ucb/tr, Solaris /usr/xpg4/bin/tr,
      Minix 3 /usr/bin/tr, and SUSv3 deficiencies
    - Fix compilation on more platforms (Interix, Cygwin, Linux 2.0 libc5,
      Debian GNU/kFreeBSD, Debian GNU/HURD, ...)
    - Use autoconfiguration for persistent history stuff
    - Fix the code (add "const" in like 1001 places) to be able to
      build without -Wno-cast-qual (hope it's safe now)
    - Optionally use const-debugging versions of strchr(3), strstr(3),
      to work around deficiencies in ANSI C
    - The above directly led to our own strcasestr(3) implementation
      for OSes which don't have it
    - Optimise dot.mkshrc macros
    - Remove shadowing warnings for more OSes
    - Support old ash(1) versions in Build.sh
    - Support use of _NSIG for NSIG
    - Optimise ctags(1) generation
  * Honour ${CC}

 -- Thorsten Glaser <tg@mirbsd.de>  Tue,  6 Mar 2007 03:44:58 +0000

mksh (28.9.20070218) experimental; urgency=low

  * New upstream development snapshot; summary of changes:
    - fix 'hd' alias in dot.mkshrc example to not run off
      an ANSI standard 80 column screen; simplify
    - integrate MKSH_NEED_MKNOD and MKSH_ASSUME_UTF8 with Build.sh

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 18 Feb 2007 20:34:48 +0000

mksh (28.9.20070216) experimental; urgency=low

  * New upstream development snapshot; summary of changes:
    - if MKSH_SMALL, don't include -T support and don't scan
      for revoke() function
    - new #ifdef MKSH_NEED_MKNOD to embed mknod(8) even if
      MKSH_SMALL is enabled
    - do not scan for revoke() on GNU/Linux since it always fails
    - simplify GNU/Linux CPPFLAGS and use them for GNU/HURD and
      GNU/kFreeBSD (tested on Debian experimental, thanks to the
      ftbfs.de autobuilder and Michael "azeem" Banck)
    - fix the 'bind' (no args) builtin output
    - new #ifdef MKSH_ASSUME_UTF8 to not check setlocale() and
      nl_langinfo(CODESET) if we want to always enable the utf-8
      command line editing mode
    - tabcomplete a newline to singlequote+newline+singlequote
      instead of backslash+newline which is eaten; thanks to
      Thomas E. "TGEN" Spanjaard for noticing
    - remove shebang line from check.pl which isn't +x anyway
  * control: add ed(1) as suggested package, for history editing
  * control, rules: add GNU screen as build dependency; use it to
    provide a tty to the regression test suite so it can succeed in
    the Debian autobuilding mechanism; tested on i386-linux, i386-hurd
  * control: only the emacs editing mode is utf-8 safe (fix description)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 16 Feb 2007 20:32:52 +0000

mksh (28.9.20070118) experimental; urgency=low

  * New upstream development snapshot; summary of changes:
    - autoconfify compiler flags, c preprocessor
    - add option to avoid pulling in getpwnam(3) in !MKSH_SMALL
    - scan for certain headers, types; improve portability
    - speed up autoconfiguration process in failure case
    - finally fix static vs dynamic linking issues
    - fix manpage (.Nm macro) glitch with GNU nroff 1.15
    - improve auto-detection of which regression tests are valid
    - mention failure to revoke(2) is possibly insecure
  * As a result of upstream changes, simplify debian/rules
  * Testsuite failues are not fatal for Debian
  * Please note: this is a development snapshot from CVS, but this
    one is deemed "gamma stadium" (i.e. more stable than beta, and
    ready for public consumption by a broad mass of testers).

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 18 Jan 2007 20:57:40 +0000

mksh (28.9.20070117) experimental; urgency=low

  * Add -fwrapv to Debian CFLAGS to prevent unexpected code behaviour
  * New upstream development snapshot; summary of changes:
    - Don't expand ~foo/ if MKSH_SMALL, spares getpwnam(3) call
    - Fix and autoconfify signal list generation
    - Build.sh now uses $TARGET_OS as "uname -s" output for cross builds
    - Set flag for regression tests that can't succeed if MKSH_SMALL
    - Don't even check for setlocale(3) if MKSH_SMALL, unless overridden
      by user / build environment
    - Scan for C Preprocessor, use $CPP if $CC -E fails
    - Fix possible nil pointer dereferences and signal name mismatches
    - Scan for __attribute__((...)) and -std=gnu99 (req'd on Solaris 10)
    - Correct $LDSTATIC logic, unbreak -d, don't let the user override (or
      need to) $SRCS, $sigseen
    - Simplify TIOCGWINSZ handling, no need to catch SIGWINCH any more;
      window size changes are processed after input line editing ends (i.e.
      the lines are entered or ESC # (emacs mode) is pressed) and at
      startup; ^L (redraw) can't change window size on the fly
    - Add -fwrapv to standard CFLAGS, just to be safe, like with when I
      added -fno-strict-aliasing; this is pending a bug fix in gcc, see
      GCC PR#30477
  * Please note: this is a development snapshot from CVS as well;
    it may be included into Debian experimental, but is not recom-
    mended for Debian testing.

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 17 Jan 2007 09:32:11 +0000

mksh (28.9.20070106) experimental; urgency=low

  * New upstream development snapshot; summary of changes:
    - Fix UTF-8 locale detection and segfaults
    - Use RLIMIT_AS if RLIMIT_VMEM is not available
  * Please note: this is a development snapshot from CVS as well;
    it may be included into Debian experimental, but is not recom-
    mended for Debian testing.

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 06 Jan 2007 18:55:09 +0000

mksh (28.9.20061211) experimental; urgency=low

  * New upstream development snapshot; summary of changes:
    - Spelling and wording fixes in the manual page and copyright file;
      keep the latter in sync with the latest MirOS licence template
    - One correct cast for the ulimit builtin
    - Portability #warning for developers (not seen on BSD, but
      yields a TODO for Debian)
  * Please note: this is a development snapshot from CVS as well;
    it may be included into Debian experimental, but is not recom-
    mended for Debian testing. If you already have 28.9.20061121,
    like the SuSE guru repository of loki, you do not need this
    minor update.

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 11 Dec 2006 21:53:42 +0000

mksh (28.9.20061121) experimental; urgency=low

  * Add -fno-strict-aliasing to default CFLAGS, as per upstream suggestion
  * New upstream development snapshot; summary of changes:
    - Fix portability of regression tests using fgrep(1), twice
    - Fix description of $RANDOM in manual page
    - Fix build under OpenSolaris Build 47 (reported in IRC)
    - Use easier __RCSID() stuff from MirOS #9-current
    - Don't shebang with spaces in test.sh creation
    - Remove -fno-strength-reduce from default CFLAGS, the compiler bug was
      fixed between gcc 2.7.2 and gcc 2.7.2.1...
    - Avoid unaligned memory access causing SIGBUS on IA-64 on Debian
    - Convert to autoconf-style check for function and header file existence
      of <sys/param.h>, arc4random(3), arc4random_push(3), setlocale(3) and
      LC_CTYPE, nl_langinfo(3) and CODESET, getmode(3) and setmode(3),
      strcasestr(3), and strlcpy(3)
    - Add set -o utf8-hack aka mksh -U which changes the Emacs editing mode
      to an experimental CESU-8 aware multibyte mode (not implemented using
      wide chars unless internally needed; does not require OS support); check
      setlocale(LC_CTYPE, "") and nl_langinfo(CODESET) if found to auto-enable
      utf-8 mode in interactive shells
    - Simplify and clean up code; try to remove or replace function calls by
      smaller equivalents; spot a few non-fatal off-by-one errors
    - If Build.sh is called with -DMKSH_SMALL in the CPPFLAGS environment
      variable, the built-in mknod(8) will not be included, and other
      functionality and verbose usage messages will be excluded; some macros
      will be turned into functions to save space and to check if the
      utf8-hack should be enabled, nl_langinfo(3) is not called. The -T
      option to mksh(1) and persistent history are not supported.
    - Hand-optimise the code to be small, even in the normal build
    - Unbreak the -d option to Build.sh
    - Check for cc options -Wno-error, -fwhole-program --combine, and (if
      MKSH_SMALL) -fno-inline and use them if they don't fail
    - The autoconf-style ("mirtoconf") checks have been enhanced,
      improved and be made more verbose by default
    - Rewrite a few functions both to save space and to simplify/unify the
      code; also spotted a few bugs in existing (inherited) code
    - Fix format string mistakes and wrong function and data prototypes
    - Correct zero-padding for right-justified strings; add regression test
    - EXECSHELL is now ${EXECSHELL:-/bin/sh} again
    - Remove duplicate code if feasible; rewrite remaining code to solve all
      use cases, or use standard library functions such as qsort(3); rework
      the ctypes and chtypes stuff, get rid of libc/ctype.h
    - Change the eaccess() code to not use setreuid(2) and friends, like
      OpenBSD ksh and apparently pdksh. I'm not too sure about the
      implications, except that they only affect setuid shell scripts.
    - Use setresuid(2) and friends, and setgroups(3) and <grp.h> instead
      of seteuid(2), setuid(2) etc. on operating systems that support them
    - Work around (i.e. remove) all but two -Wcast-qual issues
    - Work around a bug in the GNU implementation of the Berkeley mdoc macros
      which comes with GNU groff (only visible in MirOS with groff -mgdoc, but
      shows on other operating systems), discovered by crib in IRC
    - $RANDOM is always an unsigned 15-bit decimal integer, for all Korn shell
      derivates; idea from twkm in IRC
    - Improve/correct description of typeset command in manpage, and
      implementation of typeset -p in mksh
    - Remove the non-standard emacs-usemeta and vi-show8 shell options, assume
      the user either has a 7-bit environment, an 8-bit clean terminal, or a
      UTF-8 environment (preferred), and the dummy sh option
    - Build.sh fix for conservative (old) versions of gcc; help Debian
  * Mention UTF-8 support in the Debian control file's Description field
  * PLEASE NOTE: this is not intended to be uploaded into testing, because
    it is based upon a CVS checkout of mksh-current, and not of a formal
    release. The "mksh 28.9.yyyymmdd" series is based upon CVS snapshots of
    mksh-current (mksh R29-beta), and subject to changes. This part of the
    changelog might differ in the following mksh-29.0-1 upload to Debian.
    This code is *not* well-tested and may have been broken on various other
    operating systems and maybe architectures; it may have introduced further
    memory leaks. It is recommended to only use it to evaluate mksh's recent
    development and help finding bugs and fixing them. No warranty, as usual.

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 21 Nov 2006 21:49:44 +0000

mksh (28.0-3) oldstable; urgency=high

  * Fix CVE-2008-1845 (unauthenticated local privilege escalation)
    using upstream-provided diff

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 17 Apr 2008 21:55:05 +0000

mksh (28.0-2) unstable; urgency=low

  * Fix unaligned memory access on IA-64 (same fix was applied
    upstream for the next full release)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 30 Sep 2006 19:59:10 +0000

mksh (28.0-1) unstable; urgency=low

  * sample file (dot.mkshrc) is now in upstream
  * New upstream release; summary of (Debian user relevant) changes:
    - Fix some more -Wchar-subscripts
    - Adjust manual page to the fact that mksh can be used as
      /bin/sh although it's not specifically designed to
    - Correct and enhance book citation list in the manual page
    - Bring back the "version" editing command in both emacs and
      vi modes, at ESC ^V like AT&T ksh93r+
    - Fix typo which resulted in the wrong names for signals being
      printed (error codes were used instead) on GNU/Linux, Solaris
      and GNU/Cygwin. Ease changing signame/siglist sources.
    - Some more code, manual page, build system and regression test
      changes, cleanup and redundancy removal
    - Merge a few OpenBSD changes, yielding better multiline prompt
      support and textual improvements in the manual page
    - Adjust $PS1 sizing, printing, and redrawal routines
      for mksh behaviour and single- and multiline prompts
    - For the AT&T $PS1 hack (second char = CR), do not
      output the delimiting characters any more, even if they
      are printable - fixes platforms without non-printable
      characters (Interix, Cygwin) and prompt size calculation
    - Calculate length of prompt in lines and columns-of-last-line
      instead of using some tricks to skip the beginning of the prompt,
      resulting in correct redrawing of prompts with ANSI colour codes
    - Correct displaying of prompts spanning more than one line
      and/or with embedded newlines or carriage returns; correct
      documentation of $PS1 and the redraw editing command
    - Change one of the testsuite "expected failure" tests from bug
      to feature - it might actually be required by BSD make
    - Enable to bind key sequences which consist of the usual optional
      one or two praefices and the control character, as well as an
      optional trailing tilde (if the trailing character is not a tilde,
      it's processed as usual, but processing of the editing command is
      postponed until after the trailing character has been read)
    - Bind the NetBSD(R) wscons (vt220 / wsvt25), GNU screen and
      XFree86(R) (xterm-xfree86) "home", "end"
      and "delete" keys to ^A, ^E and ^D, respectively, except
      that "delete" does not act as logoff switch
    - Make sure ^T is bound to 'transpose' as documented
      (bug spotted by hondza)
    - Remove the 'stuff' and 'stuff-reset' editing commands
    - Correct the manual page regarding the 'abort' command, its
      interaction with 'search-history' and how to exit the latter
    - Bring back "set -o posix" turning off 'braceexpand'
    - Mention IRC support channel and mailing list in manual page
    - Make the "last command of a pipeline is executed in a
      subshell" issue a dependable mksh feature
    - Improve regression test comments and a few tests
    - If $RANDOM is generated from arc4random(3), display at
      most 31 bits of it like nbsh(1), instead of only 15 bits.

 -- Thorsten Glaser <tg@mirbsd.de>  Sat,  9 Sep 2006 11:49:07 +0000

mksh (27.4-2) unstable; urgency=low

  * Fix build if zsh is used as build shell by forcing /bin/sh

 -- Thorsten Glaser <tg@mirbsd.de>  Fri,  7 Jul 2006 19:25:32 +0000

mksh (27.4-1) unstable; urgency=low

  * New upstream release; summary of changes:
    - build system fixes (honour CPPFLAGS, ...)
    - documentation fixes (manual page date/version)
    - only source ${ENV:-~/.mkshrc} for interactive (FTALKING) shells
      (change in behaviour towards principle of least surprise)
    - fix "char subscripts" warnings
  * Be more verbose on build, to aid debugging the buildd logs
  * Install a sample ~/.mkshrc file showing how flexible mksh is and
    providing a bash-like $PS1 to the user
  * Add persistent (official) homepage to package description

 -- Thorsten Glaser <tg@mirbsd.de>  Tue,  4 Jul 2006 15:42:23 +0000

mksh (27.2-1) unstable; urgency=low

  * New Debian Standards-Version, no changes for us
  * New upstream release; summary of changes:
    - emacs-usemeta now behaves like vi-show8 to facilitate
      e.g. japanese UTF-8 input on the command line (such as
      filenames); be careful with 0x80-0x9F
    - portability cleanup and speed-up
    - GNU groff compatible manual page
    - add ~/.mkshrc processing, requested by Jari Aalto for
      the Debian-based Stem Desktop; see manual page for details
    - illustrate a few tricks (e.g. setting $PS1) in manual page
    - enhance testsuite
    - incorporate some more code cleanup by OpenBSD
    - reference the O'Reilly books in the manual page
  * As a result, remove some patches now in upstream
  * Add ed(1) as build dependency, needed for regression tests

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 31 May 2006 18:58:16 +0000

mksh (26.2-2) unstable; urgency=low

  * There was another .St -susv3 in the manual page;
    replace it by the expanded version.
  * No comma in front of "which" in English (copyright file)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu,  2 Feb 2006 18:08:34 +0000

mksh (26.2-1) unstable; urgency=low

  * New upstream release; summary of relevant changes:
    - Change quoting policy (regarding backslash-doublequote) in
      here documents to conform to SUSv3 (to migrate, change all
      occurences of backslash-doublequote to just doublequote)
    - Update documentation
    - Clean up code
    - Fix some more GCC 4 warnings
  * Remove no longer needed workaround

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 30 Jan 2006 12:03:02 +0000

mksh (25.0-1) unstable; urgency=low

  * New upstream release; summary of changes:
    - add a builtin: mknod (can do pipes and devices)
    - remove 'version' editor binding and remap emacs ^V to
      quote-meta ('literal')
    - fix redraw and window resize problems; COLUMNS and LINES
      are now updated as soon as the new size is set
    - allow < and > for test and [, not only [[
    - if an array index is out of bounds, tell which one
    - document quoting policy in here documents
    - correct some mistakes in the manual page
    - fixes for GCC 4 warnings
    - code and build system simplifications
  * As a result, simplify debian/rules accordingly
  * Copy all "non-standard" licences into the copyright file
  * Work around GNU groff not having .St -susv3

 -- Thorsten Glaser <tg@MirBSD.org>  Wed, 26 Oct 2005 09:27:39 +0000

mksh (24.0-1) unstable; urgency=low

  * New upstream release; relevant changes are:
     - no longer look at argv[0] to determine if restricted shell
     - changes to $EDITOR and $VISUAL no longer affect
       the current editing mode
     - emacs on, emacs-usemeta off is now the default editing mode
     - the special "posix" and "sh" modes are gone
     - code, test suites and documentation have been cleaned up a little
     - Korn's bizarre /dev/fd hack is now no longer supported
     - undo fix for Debian PR #71256 which turned to be bogus
       and break BSD make
     - fix compilation and invocation of test suite with whitespace
       in the pathnames for real, this time
  * Fix typo in description; Closes: #317785
  * Note that this is no superset of pdksh any more in description
  * New debian-policy version

 -- Thorsten Glaser <tg@MirBSD.org>  Tue, 12 Jul 2005 12:25:11 +0000

mksh (23.0-1) unstable; urgency=low

  * New upstream version
  * Clarify licence

 -- Thorsten Glaser <tg@MirBSD.org>  Wed, 22 Jun 2005 14:40:56 +0000

mksh (22.3-1) unstable; urgency=low

  * Update upstream source to mksh R22d
  * Remove some superfluous whitespace

 -- Thorsten Glaser <tg@MirBSD.org>  Sun,  5 Jun 2005 16:45:42 +0000

mksh (22.2-2) unstable; urgency=low

  * Rename postinst, prerm, menu to mksh.{postinst,prerm,menu}
  * Always run testsuite
  * Install the binary with 755 permissions
  * Remove superfluous grep in rules
    (All of the above based upon suggestions by sponsor Bastian Blank)
  * Use dh_install instead of homegrown calls (patch by Bastian Blank)
  * Regenerate .orig.tar.gz with MirBSD cpio since GNU cpio generates
    invalid ustar archives (broken mtime)

 -- Thorsten Glaser <tg@MirBSD.org>  Thu,  2 Jun 2005 07:47:33 +0000

mksh (22.2-1) unstable; urgency=low

  * Initial Release

 -- Thorsten Glaser <tg@MirBSD.org>  Sat, 28 May 2005 22:02:17 +0000
